/* FirmwareView.c generated by valac 0.56.17, the Vala compiler
 * generated from FirmwareView.vala, do not modify */

/*
* Copyright 2020-2021 elementary, Inc. (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Marius Meisenzahl <mariusmeisenzahl@gmail.com>
*/

#include "system.h"
#include <gtk/gtk.h>
#include <adwaita.h>
#include <granite-7.h>
#include <glib.h>
#include <fwupd.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>
#include <switchboard.h>

#define ABOUT_GETTEXT_PACKAGE "io.elementary.settings.system"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	ABOUT_FIRMWARE_VIEW_0_PROPERTY,
	ABOUT_FIRMWARE_VIEW_NUM_PROPERTIES
};
static GParamSpec* about_firmware_view_properties[ABOUT_FIRMWARE_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_ptr_array_unref0(var) ((var == NULL) ? NULL : (var = (g_ptr_array_unref (var), NULL)))
typedef struct _AboutFirmwareViewUpdateListViewData AboutFirmwareViewUpdateListViewData;
typedef struct _Block5Data Block5Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block6Data Block6Data;
typedef struct _Block7Data Block7Data;
typedef struct _AboutFirmwareViewUpdateData AboutFirmwareViewUpdateData;
typedef struct _AboutFirmwareViewContinueUpdateData AboutFirmwareViewContinueUpdateData;
typedef struct _AboutFirmwareViewDownloadFileData AboutFirmwareViewDownloadFileData;
typedef struct _Block8Data Block8Data;
typedef struct _Block9Data Block9Data;
typedef struct _Block10Data Block10Data;

struct _AboutFirmwareViewPrivate {
	GtkStack* stack;
	AdwLeaflet* deck;
	AboutFirmwareReleaseView* firmware_release_view;
	GranitePlaceholder* progress_alert_view;
	GranitePlaceholder* placeholder_alert_view;
	GtkListBox* update_list;
	guint num_updates;
	FwupdClient* fwupd_client;
};

struct _AboutFirmwareViewUpdateListViewData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AboutFirmwareView* self;
	GtkListBox* _tmp0_;
	GtkListBoxRow* _tmp1_;
	GtkListBox* _tmp2_;
	GtkListBox* _tmp3_;
	GtkListBoxRow* _tmp4_;
	GPtrArray* devices;
	FwupdClient* _tmp5_;
	GPtrArray* _tmp6_;
	gint i;
	gboolean _tmp7_;
	gint _tmp8_;
	GPtrArray* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	GPtrArray* _tmp12_;
	gconstpointer _tmp13_;
	GranitePlaceholder* _tmp14_;
	GranitePlaceholder* _tmp15_;
	GranitePlaceholder* _tmp16_;
	GranitePlaceholder* _tmp17_;
	GtkStack* _tmp18_;
	AdwLeaflet* _tmp19_;
	GError* _inner_error0_;
};

struct _Block5Data {
	int _ref_count_;
	AboutFirmwareView* self;
	FwupdDevice* device;
};

struct _Block6Data {
	int _ref_count_;
	AboutFirmwareView* self;
	FwupdDevice* device;
	FwupdRelease* release;
	gpointer _async_data_;
};

struct _Block7Data {
	int _ref_count_;
	Block6Data * _data6_;
	GraniteMessageDialog* details_dialog;
};

struct _AboutFirmwareViewUpdateData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AboutFirmwareView* self;
	FwupdDevice* device;
	FwupdRelease* release;
	Block6Data* _data6_;
	GranitePlaceholder* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GtkStack* _tmp4_;
	GranitePlaceholder* _tmp5_;
	const gchar* detach_caption;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	Block7Data* _data7_;
	gchar* detach_image;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	const gchar* _tmp13_;
	const gchar* _tmp14_;
	GraniteMessageDialog* _tmp15_;
	GraniteMessageDialog* _tmp16_;
	GraniteMessageDialog* _tmp17_;
};

struct _AboutFirmwareViewContinueUpdateData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AboutFirmwareView* self;
	FwupdDevice* device;
	FwupdRelease* release;
	gchar* path;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	FwupdInstallFlags install_flags;
	gboolean _tmp2_;
	FwupdClient* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	GError* e;
	GError* _tmp6_;
	const gchar* _tmp7_;
	GtkStack* _tmp8_;
	AdwLeaflet* _tmp9_;
	GError* _inner_error0_;
};

struct _AboutFirmwareViewDownloadFileData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AboutFirmwareView* self;
	FwupdDevice* device;
	gchar* uri;
	gchar* result;
	GFile* server_file;
	GFile* _tmp0_;
	gchar* path;
	const gchar* _tmp1_;
	GFile* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GFile* local_file;
	const gchar* _tmp7_;
	GFile* _tmp8_;
	gboolean _result_;
	gboolean _tmp9_;
	GFile* _tmp10_;
	GFile* _tmp11_;
	GError* e;
	GError* _tmp12_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	GError* _inner_error0_;
};

struct _Block8Data {
	int _ref_count_;
	AboutFirmwareView* self;
	GraniteMessageDialog* message_dialog;
};

struct _Block9Data {
	int _ref_count_;
	AboutFirmwareView* self;
	GraniteMessageDialog* message_dialog;
};

struct _Block10Data {
	int _ref_count_;
	AboutFirmwareView* self;
	GraniteMessageDialog* dialog;
};

static gint AboutFirmwareView_private_offset;
static gpointer about_firmware_view_parent_class = NULL;

static void about_firmware_view_update_list_view_data_free (gpointer _data);
static void about_firmware_view_update_list_view (AboutFirmwareView* self,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_);
static void about_firmware_view_update_list_view_finish (AboutFirmwareView* self,
                                                  GAsyncResult* _res_);
static gboolean about_firmware_view_update_list_view_co (AboutFirmwareViewUpdateListViewData* _data_);
static void about_firmware_view_update_list_view_ready (GObject* source_object,
                                                 GAsyncResult* _res_,
                                                 gpointer _user_data_);
static void about_firmware_view_add_device (AboutFirmwareView* self,
                                     FwupdDevice* device);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static void ___lambda23_ (Block5Data* _data5_,
                   GObject* obj,
                   GAsyncResult* res);
static void __lambda25_ (AboutFirmwareView* self,
                  FwupdDevice* device,
                  FwupdRelease* release);
static void about_firmware_view_update (AboutFirmwareView* self,
                                 FwupdDevice* device,
                                 FwupdRelease* release,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_);
static void about_firmware_view_update_finish (AboutFirmwareView* self,
                                        GAsyncResult* _res_);
static void ___lambda25__about_widgets_firmware_update_row_update (AboutWidgetsFirmwareUpdateRow* _sender,
                                                            FwupdDevice* device,
                                                            FwupdRelease* release,
                                                            gpointer self);
static void ____lambda23__gasync_ready_callback (GObject* source_object,
                                          GAsyncResult* res,
                                          gpointer self);
static void about_firmware_view_show_release (AboutFirmwareView* self,
                                       GtkListBoxRow* widget);
static void about_firmware_view_on_device_added (AboutFirmwareView* self,
                                          FwupdClient* client,
                                          FwupdDevice* device);
static void about_firmware_view_on_device_removed (AboutFirmwareView* self,
                                            FwupdClient* client,
                                            FwupdDevice* device);
static gint about_firmware_view_compare_rows (AboutWidgetsFirmwareUpdateRow* row1,
                                       AboutWidgetsFirmwareUpdateRow* row2,
                                       AboutFirmwareView* self);
static void about_firmware_view_header_rows (AboutWidgetsFirmwareUpdateRow* row1,
                                      AboutWidgetsFirmwareUpdateRow* row2,
                                      AboutFirmwareView* self);
static void about_firmware_view_update_data_free (gpointer _data);
static gboolean about_firmware_view_update_co (AboutFirmwareViewUpdateData* _data_);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
static void about_firmware_view_download_file (AboutFirmwareView* self,
                                        FwupdDevice* device,
                                        const gchar* uri,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_);
static gchar* about_firmware_view_download_file_finish (AboutFirmwareView* self,
                                                 GAsyncResult* _res_);
static void about_firmware_view_update_ready (GObject* source_object,
                                       GAsyncResult* _res_,
                                       gpointer _user_data_);
static GraniteMessageDialog* about_firmware_view_show_details_dialog (AboutFirmwareView* self,
                                                               FwupdDevice* device,
                                                               const gchar* detach_caption,
                                                               const gchar* detach_image);
static void ___lambda27_ (Block7Data* _data7_,
                   gint response);
static void about_firmware_view_continue_update (AboutFirmwareView* self,
                                          FwupdDevice* device,
                                          FwupdRelease* release,
                                          GAsyncReadyCallback _callback_,
                                          gpointer _user_data_);
static void about_firmware_view_continue_update_finish (AboutFirmwareView* self,
                                                 GAsyncResult* _res_);
static void ____lambda27__gtk_dialog_response (GtkDialog* _sender,
                                        gint response_id,
                                        gpointer self);
static void about_firmware_view_continue_update_data_free (gpointer _data);
static gboolean about_firmware_view_continue_update_co (AboutFirmwareViewContinueUpdateData* _data_);
static void about_firmware_view_continue_update_ready (GObject* source_object,
                                                GAsyncResult* _res_,
                                                gpointer _user_data_);
static void about_firmware_view_show_reboot_dialog (AboutFirmwareView* self);
static void about_firmware_view_show_shutdown_dialog (AboutFirmwareView* self);
static void about_firmware_view_show_error_dialog (AboutFirmwareView* self,
                                            FwupdDevice* device,
                                            const gchar* secondary_text);
static void about_firmware_view_download_file_data_free (gpointer _data);
static gboolean about_firmware_view_download_file_co (AboutFirmwareViewDownloadFileData* _data_);
static void ___lambda26_ (AboutFirmwareView* self,
                   gint64 current_num_bytes,
                   gint64 total_num_bytes);
static void ____lambda26__gfile_progress_callback (gint64 current_num_bytes,
                                            gint64 total_num_bytes,
                                            gpointer self);
static void about_firmware_view_download_file_ready (GObject* source_object,
                                              GAsyncResult* _res_,
                                              gpointer _user_data_);
static void _gtk_window_destroy_gtk_dialog_response (GtkDialog* _sender,
                                              gint response_id,
                                              gpointer self);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
static void __lambda28_ (Block8Data* _data8_,
                  gint response);
static void ___lambda28__gtk_dialog_response (GtkDialog* _sender,
                                       gint response_id,
                                       gpointer self);
static Block9Data* block9_data_ref (Block9Data* _data9_);
static void block9_data_unref (void * _userdata_);
static void __lambda29_ (Block9Data* _data9_,
                  gint response);
static void ___lambda29__gtk_dialog_response (GtkDialog* _sender,
                                       gint response_id,
                                       gpointer self);
static void about_firmware_view_reboot_to_firmware_setup_clicked (AboutFirmwareView* self);
static Block10Data* block10_data_ref (Block10Data* _data10_);
static void block10_data_unref (void * _userdata_);
static void __lambda30_ (Block10Data* _data10_,
                  gint _result_);
static void ___lambda30__gtk_dialog_response (GtkDialog* _sender,
                                       gint response_id,
                                       gpointer self);
static GObject * about_firmware_view_constructor (GType type,
                                           guint n_construct_properties,
                                           GObjectConstructParam * construct_properties);
static void _about_firmware_view_reboot_to_firmware_setup_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                               gpointer self);
static void _about_firmware_view_on_device_added_fwupd_client_device_added (FwupdClient* _sender,
                                                                     FwupdDevice* _result_,
                                                                     gpointer self);
static void _about_firmware_view_on_device_removed_fwupd_client_device_removed (FwupdClient* _sender,
                                                                         FwupdDevice* _result_,
                                                                         gpointer self);
static void _about_firmware_view_show_release_gtk_list_box_row_activated (GtkListBox* _sender,
                                                                   GtkListBoxRow* row,
                                                                   gpointer self);
static void _about_firmware_view___lambda31_ (AboutFirmwareView* self,
                                       FwupdDevice* device,
                                       FwupdRelease* release);
static void __about_firmware_view___lambda31__about_firmware_release_view_update (AboutFirmwareReleaseView* _sender,
                                                                           FwupdDevice* device,
                                                                           FwupdRelease* release,
                                                                           gpointer self);
static void about_firmware_view_finalize (GObject * obj);
static GType about_firmware_view_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
about_firmware_view_get_instance_private (AboutFirmwareView* self)
{
	return G_STRUCT_MEMBER_P (self, AboutFirmwareView_private_offset);
}

AboutFirmwareView*
about_firmware_view_construct (GType object_type)
{
	AboutFirmwareView * self = NULL;
	GThemedIcon* _tmp0_;
	GThemedIcon* _tmp1_;
#line 33 "../src/Views/FirmwareView.vala"
	_tmp0_ = (GThemedIcon*) g_themed_icon_new ("application-x-firmware");
#line 33 "../src/Views/FirmwareView.vala"
	_tmp1_ = _tmp0_;
#line 33 "../src/Views/FirmwareView.vala"
	self = (AboutFirmwareView*) g_object_new (object_type, "icon", _tmp1_, "title", _ ("Firmware"), "description", _ ("Firmware updates provided by device manufacturers can improve performa" \
"nce and fix critical security issues."), NULL);
#line 33 "../src/Views/FirmwareView.vala"
	_g_object_unref0 (_tmp1_);
#line 32 "../src/Views/FirmwareView.vala"
	return self;
#line 417 "FirmwareView.c"
}

AboutFirmwareView*
about_firmware_view_new (void)
{
#line 32 "../src/Views/FirmwareView.vala"
	return about_firmware_view_construct (ABOUT_TYPE_FIRMWARE_VIEW);
#line 425 "FirmwareView.c"
}

static void
about_firmware_view_update_list_view_data_free (gpointer _data)
{
	AboutFirmwareViewUpdateListViewData* _data_;
	_data_ = _data;
#line 22 "../src/Views/FirmwareView.vala"
	_g_object_unref0 (_data_->self);
#line 22 "../src/Views/FirmwareView.vala"
	g_slice_free (AboutFirmwareViewUpdateListViewData, _data_);
#line 437 "FirmwareView.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 22 "../src/Views/FirmwareView.vala"
	return self ? g_object_ref (self) : NULL;
#line 445 "FirmwareView.c"
}

static void
about_firmware_view_update_list_view (AboutFirmwareView* self,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_)
{
	AboutFirmwareViewUpdateListViewData* _data_;
	AboutFirmwareView* _tmp0_;
#line 22 "../src/Views/FirmwareView.vala"
	g_return_if_fail (self != NULL);
#line 22 "../src/Views/FirmwareView.vala"
	_data_ = g_slice_new0 (AboutFirmwareViewUpdateListViewData);
#line 22 "../src/Views/FirmwareView.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 22 "../src/Views/FirmwareView.vala"
	g_task_set_task_data (_data_->_async_result, _data_, about_firmware_view_update_list_view_data_free);
#line 22 "../src/Views/FirmwareView.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 22 "../src/Views/FirmwareView.vala"
	_data_->self = _tmp0_;
#line 22 "../src/Views/FirmwareView.vala"
	about_firmware_view_update_list_view_co (_data_);
#line 469 "FirmwareView.c"
}

static void
about_firmware_view_update_list_view_finish (AboutFirmwareView* self,
                                             GAsyncResult* _res_)
{
	AboutFirmwareViewUpdateListViewData* _data_;
#line 22 "../src/Views/FirmwareView.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 479 "FirmwareView.c"
}

static void
about_firmware_view_update_list_view_ready (GObject* source_object,
                                            GAsyncResult* _res_,
                                            gpointer _user_data_)
{
	AboutFirmwareViewUpdateListViewData* _data_;
#line 111 "../src/Views/FirmwareView.vala"
	_data_ = _user_data_;
#line 111 "../src/Views/FirmwareView.vala"
	_data_->_source_object_ = source_object;
#line 111 "../src/Views/FirmwareView.vala"
	_data_->_res_ = _res_;
#line 111 "../src/Views/FirmwareView.vala"
	about_firmware_view_update_list_view_co (_data_);
#line 496 "FirmwareView.c"
}

static gint
vala_g_ptr_array_get_length (GPtrArray* self)
{
	gint result;
#line 5950 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 5951 "glib-2.0.vapi"
	result = (gint) self->len;
#line 5951 "glib-2.0.vapi"
	return result;
#line 509 "FirmwareView.c"
}

static gboolean
about_firmware_view_update_list_view_co (AboutFirmwareViewUpdateListViewData* _data_)
{
#line 103 "../src/Views/FirmwareView.vala"
	switch (_data_->_state_) {
#line 103 "../src/Views/FirmwareView.vala"
		case 0:
#line 519 "FirmwareView.c"
		goto _state_0;
#line 103 "../src/Views/FirmwareView.vala"
		case 1:
#line 523 "FirmwareView.c"
		goto _state_1;
		default:
#line 103 "../src/Views/FirmwareView.vala"
		g_assert_not_reached ();
#line 528 "FirmwareView.c"
	}
	_state_0:
#line 104 "../src/Views/FirmwareView.vala"
	while (TRUE) {
#line 104 "../src/Views/FirmwareView.vala"
		_data_->_tmp0_ = _data_->self->priv->update_list;
#line 104 "../src/Views/FirmwareView.vala"
		_data_->_tmp1_ = gtk_list_box_get_row_at_index (_data_->_tmp0_, 0);
#line 104 "../src/Views/FirmwareView.vala"
		if (!(_data_->_tmp1_ != NULL)) {
#line 104 "../src/Views/FirmwareView.vala"
			break;
#line 541 "FirmwareView.c"
		}
#line 105 "../src/Views/FirmwareView.vala"
		_data_->_tmp2_ = _data_->self->priv->update_list;
#line 105 "../src/Views/FirmwareView.vala"
		_data_->_tmp3_ = _data_->self->priv->update_list;
#line 105 "../src/Views/FirmwareView.vala"
		_data_->_tmp4_ = gtk_list_box_get_row_at_index (_data_->_tmp3_, 0);
#line 105 "../src/Views/FirmwareView.vala"
		gtk_list_box_remove (_data_->_tmp2_, (GtkWidget*) _data_->_tmp4_);
#line 551 "FirmwareView.c"
	}
#line 108 "../src/Views/FirmwareView.vala"
	_data_->self->priv->num_updates = (guint) 0;
#line 555 "FirmwareView.c"
	{
#line 111 "../src/Views/FirmwareView.vala"
		_data_->_tmp5_ = _data_->self->priv->fwupd_client;
#line 111 "../src/Views/FirmwareView.vala"
		_data_->_state_ = 1;
#line 111 "../src/Views/FirmwareView.vala"
		about_firmware_client_get_devices (_data_->_tmp5_, about_firmware_view_update_list_view_ready, _data_);
#line 111 "../src/Views/FirmwareView.vala"
		return FALSE;
#line 565 "FirmwareView.c"
		_state_1:
#line 111 "../src/Views/FirmwareView.vala"
		_data_->_tmp6_ = about_firmware_client_get_devices_finish (_data_->_res_, &_data_->_inner_error0_);
#line 111 "../src/Views/FirmwareView.vala"
		_data_->devices = _data_->_tmp6_;
#line 111 "../src/Views/FirmwareView.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 573 "FirmwareView.c"
			goto __catch0_g_error;
		}
		{
#line 112 "../src/Views/FirmwareView.vala"
			_data_->i = 0;
#line 579 "FirmwareView.c"
			{
#line 112 "../src/Views/FirmwareView.vala"
				_data_->_tmp7_ = TRUE;
#line 112 "../src/Views/FirmwareView.vala"
				while (TRUE) {
#line 112 "../src/Views/FirmwareView.vala"
					if (!_data_->_tmp7_) {
#line 112 "../src/Views/FirmwareView.vala"
						_data_->_tmp8_ = _data_->i;
#line 112 "../src/Views/FirmwareView.vala"
						_data_->i = _data_->_tmp8_ + 1;
#line 591 "FirmwareView.c"
					}
#line 112 "../src/Views/FirmwareView.vala"
					_data_->_tmp7_ = FALSE;
#line 112 "../src/Views/FirmwareView.vala"
					_data_->_tmp9_ = _data_->devices;
#line 112 "../src/Views/FirmwareView.vala"
					_data_->_tmp10_ = vala_g_ptr_array_get_length (_data_->_tmp9_);
#line 112 "../src/Views/FirmwareView.vala"
					_data_->_tmp11_ = _data_->_tmp10_;
#line 112 "../src/Views/FirmwareView.vala"
					if (!(_data_->i < _data_->_tmp11_)) {
#line 112 "../src/Views/FirmwareView.vala"
						break;
#line 605 "FirmwareView.c"
					}
#line 113 "../src/Views/FirmwareView.vala"
					_data_->_tmp12_ = _data_->devices;
#line 113 "../src/Views/FirmwareView.vala"
					_data_->_tmp13_ = g_ptr_array_index (_data_->_tmp12_, (guint) _data_->i);
#line 113 "../src/Views/FirmwareView.vala"
					about_firmware_view_add_device (_data_->self, (FwupdDevice*) _data_->_tmp13_);
#line 613 "FirmwareView.c"
				}
			}
		}
#line 116 "../src/Views/FirmwareView.vala"
		_data_->_tmp14_ = _data_->self->priv->placeholder_alert_view;
#line 116 "../src/Views/FirmwareView.vala"
		granite_placeholder_set_title (_data_->_tmp14_, _ ("Firmware Updates Are Not Available"));
#line 117 "../src/Views/FirmwareView.vala"
		_data_->_tmp15_ = _data_->self->priv->placeholder_alert_view;
#line 117 "../src/Views/FirmwareView.vala"
		granite_placeholder_set_description (_data_->_tmp15_, _ ("Firmware updates are not supported on this or any connected devices."));
#line 110 "../src/Views/FirmwareView.vala"
		_g_ptr_array_unref0 (_data_->devices);
#line 627 "FirmwareView.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 110 "../src/Views/FirmwareView.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 119 "../src/Views/FirmwareView.vala"
		_data_->_tmp16_ = _data_->self->priv->placeholder_alert_view;
#line 119 "../src/Views/FirmwareView.vala"
		granite_placeholder_set_title (_data_->_tmp16_, _ ("The Firmware Service Is Not Available"));
#line 120 "../src/Views/FirmwareView.vala"
		_data_->_tmp17_ = _data_->self->priv->placeholder_alert_view;
#line 120 "../src/Views/FirmwareView.vala"
		granite_placeholder_set_description (_data_->_tmp17_, _ ("Please make sure “fwupd” is installed and enabled."));
#line 642 "FirmwareView.c"
	}
	__finally0:
#line 110 "../src/Views/FirmwareView.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 110 "../src/Views/FirmwareView.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 110 "../src/Views/FirmwareView.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 110 "../src/Views/FirmwareView.vala"
		g_object_unref (_data_->_async_result);
#line 110 "../src/Views/FirmwareView.vala"
		return FALSE;
#line 655 "FirmwareView.c"
	}
#line 123 "../src/Views/FirmwareView.vala"
	_data_->_tmp18_ = _data_->self->priv->stack;
#line 123 "../src/Views/FirmwareView.vala"
	_data_->_tmp19_ = _data_->self->priv->deck;
#line 123 "../src/Views/FirmwareView.vala"
	gtk_stack_set_visible_child (_data_->_tmp18_, (GtkWidget*) _data_->_tmp19_);
#line 103 "../src/Views/FirmwareView.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 103 "../src/Views/FirmwareView.vala"
	if (_data_->_state_ != 0) {
#line 103 "../src/Views/FirmwareView.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 103 "../src/Views/FirmwareView.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 671 "FirmwareView.c"
		}
	}
#line 103 "../src/Views/FirmwareView.vala"
	g_object_unref (_data_->_async_result);
#line 103 "../src/Views/FirmwareView.vala"
	return FALSE;
#line 678 "FirmwareView.c"
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 126 "../src/Views/FirmwareView.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 126 "../src/Views/FirmwareView.vala"
	return _data5_;
#line 688 "FirmwareView.c"
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 126 "../src/Views/FirmwareView.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 698 "FirmwareView.c"
		AboutFirmwareView* self;
#line 126 "../src/Views/FirmwareView.vala"
		self = _data5_->self;
#line 126 "../src/Views/FirmwareView.vala"
		_g_object_unref0 (_data5_->device);
#line 126 "../src/Views/FirmwareView.vala"
		_g_object_unref0 (self);
#line 126 "../src/Views/FirmwareView.vala"
		g_slice_free (Block5Data, _data5_);
#line 708 "FirmwareView.c"
	}
}

static void
__lambda25_ (AboutFirmwareView* self,
             FwupdDevice* device,
             FwupdRelease* release)
{
#line 149 "../src/Views/FirmwareView.vala"
	g_return_if_fail (device != NULL);
#line 149 "../src/Views/FirmwareView.vala"
	g_return_if_fail (release != NULL);
#line 150 "../src/Views/FirmwareView.vala"
	about_firmware_view_update (self, device, release, NULL, NULL);
#line 723 "FirmwareView.c"
}

static void
___lambda25__about_widgets_firmware_update_row_update (AboutWidgetsFirmwareUpdateRow* _sender,
                                                       FwupdDevice* device,
                                                       FwupdRelease* release,
                                                       gpointer self)
{
#line 149 "../src/Views/FirmwareView.vala"
	__lambda25_ ((AboutFirmwareView*) self, device, release);
#line 734 "FirmwareView.c"
}

static void
___lambda23_ (Block5Data* _data5_,
              GObject* obj,
              GAsyncResult* res)
{
	AboutFirmwareView* self;
	FwupdRelease* release = NULL;
	AboutWidgetsFirmwareUpdateRow* row = NULL;
	FwupdRelease* _tmp5_;
	AboutWidgetsFirmwareUpdateRow* _tmp6_;
	AboutWidgetsFirmwareUpdateRow* _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp9_;
	GtkListBox* _tmp11_;
	AboutWidgetsFirmwareUpdateRow* _tmp12_;
	GtkListBox* _tmp13_;
	AboutWidgetsFirmwareUpdateRow* _tmp14_;
	GError* _inner_error0_ = NULL;
#line 128 "../src/Views/FirmwareView.vala"
	self = _data5_->self;
#line 128 "../src/Views/FirmwareView.vala"
	g_return_if_fail (res != NULL);
#line 129 "../src/Views/FirmwareView.vala"
	release = NULL;
#line 761 "FirmwareView.c"
	{
		GPtrArray* upgrades = NULL;
		GPtrArray* _tmp0_;
#line 132 "../src/Views/FirmwareView.vala"
		_tmp0_ = about_firmware_client_get_upgrades_finish (res, &_inner_error0_);
#line 132 "../src/Views/FirmwareView.vala"
		upgrades = _tmp0_;
#line 132 "../src/Views/FirmwareView.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 771 "FirmwareView.c"
			goto __catch0_g_error;
		}
#line 133 "../src/Views/FirmwareView.vala"
		if (upgrades != NULL) {
#line 776 "FirmwareView.c"
			gconstpointer _tmp1_;
			FwupdRelease* _tmp2_;
#line 134 "../src/Views/FirmwareView.vala"
			_tmp1_ = g_ptr_array_index (upgrades, (guint) 0);
#line 134 "../src/Views/FirmwareView.vala"
			_tmp2_ = _g_object_ref0 ((FwupdRelease*) _tmp1_);
#line 134 "../src/Views/FirmwareView.vala"
			_g_object_unref0 (release);
#line 134 "../src/Views/FirmwareView.vala"
			release = _tmp2_;
#line 787 "FirmwareView.c"
		}
#line 131 "../src/Views/FirmwareView.vala"
		_g_ptr_array_unref0 (upgrades);
#line 791 "FirmwareView.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 131 "../src/Views/FirmwareView.vala"
		e = _inner_error0_;
#line 131 "../src/Views/FirmwareView.vala"
		_inner_error0_ = NULL;
#line 137 "../src/Views/FirmwareView.vala"
		_tmp3_ = e;
#line 137 "../src/Views/FirmwareView.vala"
		_tmp4_ = _tmp3_->message;
#line 137 "../src/Views/FirmwareView.vala"
		g_debug ("FirmwareView.vala:137: %s", _tmp4_);
#line 131 "../src/Views/FirmwareView.vala"
		_g_error_free0 (e);
#line 811 "FirmwareView.c"
	}
	__finally0:
#line 131 "../src/Views/FirmwareView.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 131 "../src/Views/FirmwareView.vala"
		_g_object_unref0 (release);
#line 131 "../src/Views/FirmwareView.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 131 "../src/Views/FirmwareView.vala"
		g_clear_error (&_inner_error0_);
#line 131 "../src/Views/FirmwareView.vala"
		return;
#line 824 "FirmwareView.c"
	}
#line 140 "../src/Views/FirmwareView.vala"
	_tmp5_ = release;
#line 140 "../src/Views/FirmwareView.vala"
	_tmp6_ = about_widgets_firmware_update_row_new (_data5_->device, _tmp5_);
#line 140 "../src/Views/FirmwareView.vala"
	g_object_ref_sink (_tmp6_);
#line 140 "../src/Views/FirmwareView.vala"
	row = _tmp6_;
#line 142 "../src/Views/FirmwareView.vala"
	_tmp7_ = row;
#line 142 "../src/Views/FirmwareView.vala"
	_tmp8_ = about_widgets_firmware_update_row_get_is_updatable (_tmp7_);
#line 142 "../src/Views/FirmwareView.vala"
	_tmp9_ = _tmp8_;
#line 142 "../src/Views/FirmwareView.vala"
	if (_tmp9_) {
#line 842 "FirmwareView.c"
		guint _tmp10_;
#line 143 "../src/Views/FirmwareView.vala"
		_tmp10_ = self->priv->num_updates;
#line 143 "../src/Views/FirmwareView.vala"
		self->priv->num_updates = _tmp10_ + 1;
#line 848 "FirmwareView.c"
	}
#line 146 "../src/Views/FirmwareView.vala"
	_tmp11_ = self->priv->update_list;
#line 146 "../src/Views/FirmwareView.vala"
	_tmp12_ = row;
#line 146 "../src/Views/FirmwareView.vala"
	gtk_list_box_append (_tmp11_, (GtkWidget*) _tmp12_);
#line 147 "../src/Views/FirmwareView.vala"
	_tmp13_ = self->priv->update_list;
#line 147 "../src/Views/FirmwareView.vala"
	gtk_list_box_invalidate_sort (_tmp13_);
#line 149 "../src/Views/FirmwareView.vala"
	_tmp14_ = row;
#line 149 "../src/Views/FirmwareView.vala"
	g_signal_connect_object (_tmp14_, "update", (GCallback) ___lambda25__about_widgets_firmware_update_row_update, self, 0);
#line 128 "../src/Views/FirmwareView.vala"
	_g_object_unref0 (row);
#line 128 "../src/Views/FirmwareView.vala"
	_g_object_unref0 (release);
#line 868 "FirmwareView.c"
}

static void
____lambda23__gasync_ready_callback (GObject* source_object,
                                     GAsyncResult* res,
                                     gpointer self)
{
#line 128 "../src/Views/FirmwareView.vala"
	___lambda23_ (self, source_object, res);
#line 128 "../src/Views/FirmwareView.vala"
	block5_data_unref (self);
#line 880 "FirmwareView.c"
}

static void
about_firmware_view_add_device (AboutFirmwareView* self,
                                FwupdDevice* device)
{
	Block5Data* _data5_;
	FwupdDevice* _tmp0_;
#line 126 "../src/Views/FirmwareView.vala"
	g_return_if_fail (self != NULL);
#line 126 "../src/Views/FirmwareView.vala"
	g_return_if_fail (device != NULL);
#line 126 "../src/Views/FirmwareView.vala"
	_data5_ = g_slice_new0 (Block5Data);
#line 126 "../src/Views/FirmwareView.vala"
	_data5_->_ref_count_ = 1;
#line 126 "../src/Views/FirmwareView.vala"
	_data5_->self = g_object_ref (self);
#line 126 "../src/Views/FirmwareView.vala"
	_tmp0_ = _g_object_ref0 (device);
#line 126 "../src/Views/FirmwareView.vala"
	_g_object_unref0 (_data5_->device);
#line 126 "../src/Views/FirmwareView.vala"
	_data5_->device = _tmp0_;
#line 127 "../src/Views/FirmwareView.vala"
	if (fwupd_device_has_flag (_data5_->device, (FwupdDeviceFlags) FWUPD_DEVICE_FLAG_UPDATABLE)) {
#line 907 "FirmwareView.c"
		FwupdClient* _tmp1_;
		const gchar* _tmp2_;
#line 128 "../src/Views/FirmwareView.vala"
		_tmp1_ = self->priv->fwupd_client;
#line 128 "../src/Views/FirmwareView.vala"
		_tmp2_ = fwupd_device_get_id (_data5_->device);
#line 128 "../src/Views/FirmwareView.vala"
		about_firmware_client_get_upgrades (_tmp1_, _tmp2_, ____lambda23__gasync_ready_callback, block5_data_ref (_data5_));
#line 916 "FirmwareView.c"
	}
#line 126 "../src/Views/FirmwareView.vala"
	block5_data_unref (_data5_);
#line 126 "../src/Views/FirmwareView.vala"
	_data5_ = NULL;
#line 922 "FirmwareView.c"
}

static void
about_firmware_view_show_release (AboutFirmwareView* self,
                                  GtkListBoxRow* widget)
{
#line 156 "../src/Views/FirmwareView.vala"
	g_return_if_fail (self != NULL);
#line 156 "../src/Views/FirmwareView.vala"
	g_return_if_fail (widget != NULL);
#line 157 "../src/Views/FirmwareView.vala"
	if (ABOUT_WIDGETS_IS_FIRMWARE_UPDATE_ROW (widget)) {
#line 935 "FirmwareView.c"
		AboutWidgetsFirmwareUpdateRow* row = NULL;
		AboutWidgetsFirmwareUpdateRow* _tmp0_;
		AboutFirmwareReleaseView* _tmp1_;
		AboutWidgetsFirmwareUpdateRow* _tmp2_;
		FwupdDevice* _tmp3_;
		FwupdDevice* _tmp4_;
		AboutWidgetsFirmwareUpdateRow* _tmp5_;
		FwupdRelease* _tmp6_;
		FwupdRelease* _tmp7_;
		AdwLeaflet* _tmp8_;
		AboutFirmwareReleaseView* _tmp9_;
#line 158 "../src/Views/FirmwareView.vala"
		_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (widget, ABOUT_WIDGETS_TYPE_FIRMWARE_UPDATE_ROW, AboutWidgetsFirmwareUpdateRow));
#line 158 "../src/Views/FirmwareView.vala"
		row = _tmp0_;
#line 159 "../src/Views/FirmwareView.vala"
		_tmp1_ = self->priv->firmware_release_view;
#line 159 "../src/Views/FirmwareView.vala"
		_tmp2_ = row;
#line 159 "../src/Views/FirmwareView.vala"
		_tmp3_ = about_widgets_firmware_update_row_get_device (_tmp2_);
#line 159 "../src/Views/FirmwareView.vala"
		_tmp4_ = _tmp3_;
#line 159 "../src/Views/FirmwareView.vala"
		_tmp5_ = row;
#line 159 "../src/Views/FirmwareView.vala"
		_tmp6_ = about_widgets_firmware_update_row_get_release (_tmp5_);
#line 159 "../src/Views/FirmwareView.vala"
		_tmp7_ = _tmp6_;
#line 159 "../src/Views/FirmwareView.vala"
		about_firmware_release_view_update_view (_tmp1_, _tmp4_, _tmp7_);
#line 160 "../src/Views/FirmwareView.vala"
		_tmp8_ = self->priv->deck;
#line 160 "../src/Views/FirmwareView.vala"
		_tmp9_ = self->priv->firmware_release_view;
#line 160 "../src/Views/FirmwareView.vala"
		adw_leaflet_set_visible_child (_tmp8_, (GtkWidget*) _tmp9_);
#line 157 "../src/Views/FirmwareView.vala"
		_g_object_unref0 (row);
#line 975 "FirmwareView.c"
	}
}

static void
about_firmware_view_on_device_added (AboutFirmwareView* self,
                                     FwupdClient* client,
                                     FwupdDevice* device)
{
	const gchar* _tmp0_;
	GtkStack* _tmp1_;
	AdwLeaflet* _tmp2_;
#line 164 "../src/Views/FirmwareView.vala"
	g_return_if_fail (self != NULL);
#line 164 "../src/Views/FirmwareView.vala"
	g_return_if_fail (client != NULL);
#line 164 "../src/Views/FirmwareView.vala"
	g_return_if_fail (device != NULL);
#line 165 "../src/Views/FirmwareView.vala"
	_tmp0_ = fwupd_device_get_name (device);
#line 165 "../src/Views/FirmwareView.vala"
	g_debug ("FirmwareView.vala:165: Added device: %s", _tmp0_);
#line 167 "../src/Views/FirmwareView.vala"
	about_firmware_view_add_device (self, device);
#line 169 "../src/Views/FirmwareView.vala"
	_tmp1_ = self->priv->stack;
#line 169 "../src/Views/FirmwareView.vala"
	_tmp2_ = self->priv->deck;
#line 169 "../src/Views/FirmwareView.vala"
	gtk_stack_set_visible_child (_tmp1_, (GtkWidget*) _tmp2_);
#line 1005 "FirmwareView.c"
}

static void
about_firmware_view_on_device_removed (AboutFirmwareView* self,
                                       FwupdClient* client,
                                       FwupdDevice* device)
{
	const gchar* _tmp0_;
	GtkWidget* child = NULL;
	GtkListBox* _tmp1_;
	GtkWidget* _tmp2_;
	GtkListBox* _tmp21_;
#line 172 "../src/Views/FirmwareView.vala"
	g_return_if_fail (self != NULL);
#line 172 "../src/Views/FirmwareView.vala"
	g_return_if_fail (client != NULL);
#line 172 "../src/Views/FirmwareView.vala"
	g_return_if_fail (device != NULL);
#line 173 "../src/Views/FirmwareView.vala"
	_tmp0_ = fwupd_device_get_name (device);
#line 173 "../src/Views/FirmwareView.vala"
	g_debug ("FirmwareView.vala:173: Removed device: %s", _tmp0_);
#line 175 "../src/Views/FirmwareView.vala"
	_tmp1_ = self->priv->update_list;
#line 175 "../src/Views/FirmwareView.vala"
	_tmp2_ = gtk_widget_get_first_child ((GtkWidget*) _tmp1_);
#line 175 "../src/Views/FirmwareView.vala"
	child = _tmp2_;
#line 176 "../src/Views/FirmwareView.vala"
	while (TRUE) {
#line 1036 "FirmwareView.c"
		GtkWidget* _tmp3_;
		AboutWidgetsFirmwareUpdateRow* row = NULL;
		GtkWidget* _tmp4_;
		GtkWidget* _tmp7_;
		GtkWidget* _tmp8_;
		AboutWidgetsFirmwareUpdateRow* _tmp9_;
#line 176 "../src/Views/FirmwareView.vala"
		_tmp3_ = child;
#line 176 "../src/Views/FirmwareView.vala"
		if (!(_tmp3_ != NULL)) {
#line 176 "../src/Views/FirmwareView.vala"
			break;
#line 1049 "FirmwareView.c"
		}
#line 177 "../src/Views/FirmwareView.vala"
		row = NULL;
#line 178 "../src/Views/FirmwareView.vala"
		_tmp4_ = child;
#line 178 "../src/Views/FirmwareView.vala"
		if (ABOUT_WIDGETS_IS_FIRMWARE_UPDATE_ROW (_tmp4_)) {
#line 1057 "FirmwareView.c"
			GtkWidget* _tmp5_;
			AboutWidgetsFirmwareUpdateRow* _tmp6_;
#line 179 "../src/Views/FirmwareView.vala"
			_tmp5_ = child;
#line 179 "../src/Views/FirmwareView.vala"
			_tmp6_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, ABOUT_WIDGETS_TYPE_FIRMWARE_UPDATE_ROW, AboutWidgetsFirmwareUpdateRow));
#line 179 "../src/Views/FirmwareView.vala"
			_g_object_unref0 (row);
#line 179 "../src/Views/FirmwareView.vala"
			row = _tmp6_;
#line 1068 "FirmwareView.c"
		}
#line 182 "../src/Views/FirmwareView.vala"
		_tmp7_ = child;
#line 182 "../src/Views/FirmwareView.vala"
		_tmp8_ = gtk_widget_get_next_sibling (_tmp7_);
#line 182 "../src/Views/FirmwareView.vala"
		child = _tmp8_;
#line 184 "../src/Views/FirmwareView.vala"
		_tmp9_ = row;
#line 184 "../src/Views/FirmwareView.vala"
		if (_tmp9_ != NULL) {
#line 1080 "FirmwareView.c"
			AboutWidgetsFirmwareUpdateRow* _tmp10_;
			FwupdDevice* _tmp11_;
			FwupdDevice* _tmp12_;
			const gchar* _tmp13_;
			const gchar* _tmp14_;
#line 185 "../src/Views/FirmwareView.vala"
			_tmp10_ = row;
#line 185 "../src/Views/FirmwareView.vala"
			_tmp11_ = about_widgets_firmware_update_row_get_device (_tmp10_);
#line 185 "../src/Views/FirmwareView.vala"
			_tmp12_ = _tmp11_;
#line 185 "../src/Views/FirmwareView.vala"
			_tmp13_ = fwupd_device_get_id (_tmp12_);
#line 185 "../src/Views/FirmwareView.vala"
			_tmp14_ = fwupd_device_get_id (device);
#line 185 "../src/Views/FirmwareView.vala"
			if (g_strcmp0 (_tmp13_, _tmp14_) == 0) {
#line 1098 "FirmwareView.c"
				AboutWidgetsFirmwareUpdateRow* _tmp15_;
				gboolean _tmp16_;
				gboolean _tmp17_;
				GtkListBox* _tmp19_;
				AboutWidgetsFirmwareUpdateRow* _tmp20_;
#line 186 "../src/Views/FirmwareView.vala"
				_tmp15_ = row;
#line 186 "../src/Views/FirmwareView.vala"
				_tmp16_ = about_widgets_firmware_update_row_get_is_updatable (_tmp15_);
#line 186 "../src/Views/FirmwareView.vala"
				_tmp17_ = _tmp16_;
#line 186 "../src/Views/FirmwareView.vala"
				if (_tmp17_) {
#line 1112 "FirmwareView.c"
					guint _tmp18_;
#line 187 "../src/Views/FirmwareView.vala"
					_tmp18_ = self->priv->num_updates;
#line 187 "../src/Views/FirmwareView.vala"
					self->priv->num_updates = _tmp18_ - 1;
#line 1118 "FirmwareView.c"
				}
#line 190 "../src/Views/FirmwareView.vala"
				_tmp19_ = self->priv->update_list;
#line 190 "../src/Views/FirmwareView.vala"
				_tmp20_ = row;
#line 190 "../src/Views/FirmwareView.vala"
				gtk_list_box_remove (_tmp19_, (GtkWidget*) _tmp20_);
#line 1126 "FirmwareView.c"
			}
		}
#line 176 "../src/Views/FirmwareView.vala"
		_g_object_unref0 (row);
#line 1131 "FirmwareView.c"
	}
#line 195 "../src/Views/FirmwareView.vala"
	_tmp21_ = self->priv->update_list;
#line 195 "../src/Views/FirmwareView.vala"
	gtk_list_box_invalidate_sort (_tmp21_);
#line 1137 "FirmwareView.c"
}

static gint
about_firmware_view_compare_rows (AboutWidgetsFirmwareUpdateRow* row1,
                                  AboutWidgetsFirmwareUpdateRow* row2,
                                  AboutFirmwareView* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_;
	gboolean _tmp7_;
	FwupdDevice* _tmp10_;
	FwupdDevice* _tmp11_;
	const gchar* _tmp12_;
	FwupdDevice* _tmp13_;
	FwupdDevice* _tmp14_;
	const gchar* _tmp15_;
	gint result;
#line 199 "../src/Views/FirmwareView.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 199 "../src/Views/FirmwareView.vala"
	g_return_val_if_fail (row1 != NULL, 0);
#line 199 "../src/Views/FirmwareView.vala"
	g_return_val_if_fail (row2 != NULL, 0);
#line 200 "../src/Views/FirmwareView.vala"
	_tmp1_ = about_widgets_firmware_update_row_get_is_updatable (row1);
#line 200 "../src/Views/FirmwareView.vala"
	_tmp2_ = _tmp1_;
#line 200 "../src/Views/FirmwareView.vala"
	if (_tmp2_) {
#line 1170 "FirmwareView.c"
		gboolean _tmp3_;
		gboolean _tmp4_;
#line 200 "../src/Views/FirmwareView.vala"
		_tmp3_ = about_widgets_firmware_update_row_get_is_updatable (row2);
#line 200 "../src/Views/FirmwareView.vala"
		_tmp4_ = _tmp3_;
#line 200 "../src/Views/FirmwareView.vala"
		_tmp0_ = !_tmp4_;
#line 1179 "FirmwareView.c"
	} else {
#line 200 "../src/Views/FirmwareView.vala"
		_tmp0_ = FALSE;
#line 1183 "FirmwareView.c"
	}
#line 200 "../src/Views/FirmwareView.vala"
	if (_tmp0_) {
#line 201 "../src/Views/FirmwareView.vala"
		result = -1;
#line 201 "../src/Views/FirmwareView.vala"
		return result;
#line 1191 "FirmwareView.c"
	}
#line 204 "../src/Views/FirmwareView.vala"
	_tmp6_ = about_widgets_firmware_update_row_get_is_updatable (row1);
#line 204 "../src/Views/FirmwareView.vala"
	_tmp7_ = _tmp6_;
#line 204 "../src/Views/FirmwareView.vala"
	if (!_tmp7_) {
#line 1199 "FirmwareView.c"
		gboolean _tmp8_;
		gboolean _tmp9_;
#line 204 "../src/Views/FirmwareView.vala"
		_tmp8_ = about_widgets_firmware_update_row_get_is_updatable (row2);
#line 204 "../src/Views/FirmwareView.vala"
		_tmp9_ = _tmp8_;
#line 204 "../src/Views/FirmwareView.vala"
		_tmp5_ = _tmp9_;
#line 1208 "FirmwareView.c"
	} else {
#line 204 "../src/Views/FirmwareView.vala"
		_tmp5_ = FALSE;
#line 1212 "FirmwareView.c"
	}
#line 204 "../src/Views/FirmwareView.vala"
	if (_tmp5_) {
#line 205 "../src/Views/FirmwareView.vala"
		result = 1;
#line 205 "../src/Views/FirmwareView.vala"
		return result;
#line 1220 "FirmwareView.c"
	}
#line 208 "../src/Views/FirmwareView.vala"
	_tmp10_ = about_widgets_firmware_update_row_get_device (row1);
#line 208 "../src/Views/FirmwareView.vala"
	_tmp11_ = _tmp10_;
#line 208 "../src/Views/FirmwareView.vala"
	_tmp12_ = fwupd_device_get_name (_tmp11_);
#line 208 "../src/Views/FirmwareView.vala"
	_tmp13_ = about_widgets_firmware_update_row_get_device (row2);
#line 208 "../src/Views/FirmwareView.vala"
	_tmp14_ = _tmp13_;
#line 208 "../src/Views/FirmwareView.vala"
	_tmp15_ = fwupd_device_get_name (_tmp14_);
#line 208 "../src/Views/FirmwareView.vala"
	result = g_utf8_collate (_tmp12_, _tmp15_);
#line 208 "../src/Views/FirmwareView.vala"
	return result;
#line 1238 "FirmwareView.c"
}

static void
about_firmware_view_header_rows (AboutWidgetsFirmwareUpdateRow* row1,
                                 AboutWidgetsFirmwareUpdateRow* row2,
                                 AboutFirmwareView* self)
{
	gboolean _tmp0_ = FALSE;
#line 212 "../src/Views/FirmwareView.vala"
	g_return_if_fail (self != NULL);
#line 212 "../src/Views/FirmwareView.vala"
	g_return_if_fail (row1 != NULL);
#line 213 "../src/Views/FirmwareView.vala"
	if (row2 == NULL) {
#line 1253 "FirmwareView.c"
		gboolean _tmp1_;
		gboolean _tmp2_;
#line 213 "../src/Views/FirmwareView.vala"
		_tmp1_ = about_widgets_firmware_update_row_get_is_updatable (row1);
#line 213 "../src/Views/FirmwareView.vala"
		_tmp2_ = _tmp1_;
#line 213 "../src/Views/FirmwareView.vala"
		_tmp0_ = _tmp2_;
#line 1262 "FirmwareView.c"
	} else {
#line 213 "../src/Views/FirmwareView.vala"
		_tmp0_ = FALSE;
#line 1266 "FirmwareView.c"
	}
#line 213 "../src/Views/FirmwareView.vala"
	if (_tmp0_) {
#line 1270 "FirmwareView.c"
		GraniteHeaderLabel* header = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GraniteHeaderLabel* _tmp5_;
		GraniteHeaderLabel* _tmp6_;
		GraniteHeaderLabel* _tmp7_;
#line 214 "../src/Views/FirmwareView.vala"
		_tmp3_ = g_strdup_printf (g_dngettext (ABOUT_GETTEXT_PACKAGE, "%u Update Available", "%u Updates Available", (gulong) self->priv->num_updates), self->priv->num_updates);
#line 214 "../src/Views/FirmwareView.vala"
		_tmp4_ = _tmp3_;
#line 214 "../src/Views/FirmwareView.vala"
		_tmp5_ = granite_header_label_new (_tmp4_);
#line 214 "../src/Views/FirmwareView.vala"
		g_object_ref_sink (_tmp5_);
#line 214 "../src/Views/FirmwareView.vala"
		_tmp6_ = _tmp5_;
#line 214 "../src/Views/FirmwareView.vala"
		_g_free0 (_tmp4_);
#line 214 "../src/Views/FirmwareView.vala"
		header = _tmp6_;
#line 217 "../src/Views/FirmwareView.vala"
		_tmp7_ = header;
#line 217 "../src/Views/FirmwareView.vala"
		gtk_list_box_row_set_header ((GtkListBoxRow*) row1, (GtkWidget*) _tmp7_);
#line 213 "../src/Views/FirmwareView.vala"
		_g_object_unref0 (header);
#line 1297 "FirmwareView.c"
	} else {
		gboolean _tmp8_ = FALSE;
#line 218 "../src/Views/FirmwareView.vala"
		if (row2 == NULL) {
#line 218 "../src/Views/FirmwareView.vala"
			_tmp8_ = TRUE;
#line 1304 "FirmwareView.c"
		} else {
			gboolean _tmp9_;
			gboolean _tmp10_;
			gboolean _tmp11_;
			gboolean _tmp12_;
#line 218 "../src/Views/FirmwareView.vala"
			_tmp9_ = about_widgets_firmware_update_row_get_is_updatable (row1);
#line 218 "../src/Views/FirmwareView.vala"
			_tmp10_ = _tmp9_;
#line 218 "../src/Views/FirmwareView.vala"
			_tmp11_ = about_widgets_firmware_update_row_get_is_updatable (row2);
#line 218 "../src/Views/FirmwareView.vala"
			_tmp12_ = _tmp11_;
#line 218 "../src/Views/FirmwareView.vala"
			_tmp8_ = _tmp10_ != _tmp12_;
#line 1320 "FirmwareView.c"
		}
#line 218 "../src/Views/FirmwareView.vala"
		if (_tmp8_) {
#line 1324 "FirmwareView.c"
			GraniteHeaderLabel* header = NULL;
			GraniteHeaderLabel* _tmp13_;
			GraniteHeaderLabel* _tmp14_;
#line 219 "../src/Views/FirmwareView.vala"
			_tmp13_ = granite_header_label_new (_ ("Up to Date"));
#line 219 "../src/Views/FirmwareView.vala"
			g_object_ref_sink (_tmp13_);
#line 219 "../src/Views/FirmwareView.vala"
			header = _tmp13_;
#line 220 "../src/Views/FirmwareView.vala"
			_tmp14_ = header;
#line 220 "../src/Views/FirmwareView.vala"
			gtk_list_box_row_set_header ((GtkListBoxRow*) row1, (GtkWidget*) _tmp14_);
#line 218 "../src/Views/FirmwareView.vala"
			_g_object_unref0 (header);
#line 1340 "FirmwareView.c"
		} else {
#line 222 "../src/Views/FirmwareView.vala"
			gtk_list_box_row_set_header ((GtkListBoxRow*) row1, NULL);
#line 1344 "FirmwareView.c"
		}
	}
}

static void
about_firmware_view_update_data_free (gpointer _data)
{
	AboutFirmwareViewUpdateData* _data_;
	_data_ = _data;
#line 22 "../src/Views/FirmwareView.vala"
	_g_object_unref0 (_data_->self);
#line 22 "../src/Views/FirmwareView.vala"
	g_slice_free (AboutFirmwareViewUpdateData, _data_);
#line 1358 "FirmwareView.c"
}

static void
about_firmware_view_update (AboutFirmwareView* self,
                            FwupdDevice* device,
                            FwupdRelease* release,
                            GAsyncReadyCallback _callback_,
                            gpointer _user_data_)
{
	AboutFirmwareViewUpdateData* _data_;
	AboutFirmwareView* _tmp0_;
	FwupdDevice* _tmp1_;
	FwupdRelease* _tmp2_;
#line 22 "../src/Views/FirmwareView.vala"
	g_return_if_fail (self != NULL);
#line 22 "../src/Views/FirmwareView.vala"
	g_return_if_fail (device != NULL);
#line 22 "../src/Views/FirmwareView.vala"
	g_return_if_fail (release != NULL);
#line 22 "../src/Views/FirmwareView.vala"
	_data_ = g_slice_new0 (AboutFirmwareViewUpdateData);
#line 22 "../src/Views/FirmwareView.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 22 "../src/Views/FirmwareView.vala"
	g_task_set_task_data (_data_->_async_result, _data_, about_firmware_view_update_data_free);
#line 22 "../src/Views/FirmwareView.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 22 "../src/Views/FirmwareView.vala"
	_data_->self = _tmp0_;
#line 22 "../src/Views/FirmwareView.vala"
	_tmp1_ = _g_object_ref0 (device);
#line 22 "../src/Views/FirmwareView.vala"
	_g_object_unref0 (_data_->device);
#line 22 "../src/Views/FirmwareView.vala"
	_data_->device = _tmp1_;
#line 22 "../src/Views/FirmwareView.vala"
	_tmp2_ = _g_object_ref0 (release);
#line 22 "../src/Views/FirmwareView.vala"
	_g_object_unref0 (_data_->release);
#line 22 "../src/Views/FirmwareView.vala"
	_data_->release = _tmp2_;
#line 22 "../src/Views/FirmwareView.vala"
	about_firmware_view_update_co (_data_);
#line 1402 "FirmwareView.c"
}

static void
about_firmware_view_update_finish (AboutFirmwareView* self,
                                   GAsyncResult* _res_)
{
	AboutFirmwareViewUpdateData* _data_;
#line 22 "../src/Views/FirmwareView.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1412 "FirmwareView.c"
}

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
#line 226 "../src/Views/FirmwareView.vala"
	g_atomic_int_inc (&_data6_->_ref_count_);
#line 226 "../src/Views/FirmwareView.vala"
	return _data6_;
#line 1422 "FirmwareView.c"
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
#line 226 "../src/Views/FirmwareView.vala"
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
#line 1432 "FirmwareView.c"
		AboutFirmwareView* self;
#line 226 "../src/Views/FirmwareView.vala"
		self = _data6_->self;
#line 226 "../src/Views/FirmwareView.vala"
		_g_object_unref0 (_data6_->device);
#line 226 "../src/Views/FirmwareView.vala"
		_g_object_unref0 (_data6_->release);
#line 226 "../src/Views/FirmwareView.vala"
		_g_object_unref0 (self);
#line 226 "../src/Views/FirmwareView.vala"
		g_slice_free (Block6Data, _data6_);
#line 1444 "FirmwareView.c"
	}
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
#line 231 "../src/Views/FirmwareView.vala"
	g_atomic_int_inc (&_data7_->_ref_count_);
#line 231 "../src/Views/FirmwareView.vala"
	return _data7_;
#line 1455 "FirmwareView.c"
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
#line 231 "../src/Views/FirmwareView.vala"
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
#line 1465 "FirmwareView.c"
		AboutFirmwareView* self;
#line 231 "../src/Views/FirmwareView.vala"
		self = _data7_->_data6_->self;
#line 231 "../src/Views/FirmwareView.vala"
		_g_object_unref0 (_data7_->details_dialog);
#line 231 "../src/Views/FirmwareView.vala"
		block6_data_unref (_data7_->_data6_);
#line 231 "../src/Views/FirmwareView.vala"
		_data7_->_data6_ = NULL;
#line 231 "../src/Views/FirmwareView.vala"
		g_slice_free (Block7Data, _data7_);
#line 1477 "FirmwareView.c"
	}
}

static void
about_firmware_view_update_ready (GObject* source_object,
                                  GAsyncResult* _res_,
                                  gpointer _user_data_)
{
	AboutFirmwareViewUpdateData* _data_;
#line 235 "../src/Views/FirmwareView.vala"
	_data_ = _user_data_;
#line 235 "../src/Views/FirmwareView.vala"
	_data_->_source_object_ = source_object;
#line 235 "../src/Views/FirmwareView.vala"
	_data_->_res_ = _res_;
#line 235 "../src/Views/FirmwareView.vala"
	about_firmware_view_update_co (_data_);
#line 1495 "FirmwareView.c"
}

static void
___lambda27_ (Block7Data* _data7_,
              gint response)
{
	Block6Data* _data6_;
	AboutFirmwareView* self;
	GraniteMessageDialog* _tmp0_;
#line 239 "../src/Views/FirmwareView.vala"
	_data6_ = _data7_->_data6_;
#line 239 "../src/Views/FirmwareView.vala"
	self = _data6_->self;
#line 240 "../src/Views/FirmwareView.vala"
	_tmp0_ = _data7_->details_dialog;
#line 240 "../src/Views/FirmwareView.vala"
	gtk_window_destroy ((GtkWindow*) _tmp0_);
#line 241 "../src/Views/FirmwareView.vala"
	if (response == ((gint) GTK_RESPONSE_ACCEPT)) {
#line 242 "../src/Views/FirmwareView.vala"
		about_firmware_view_continue_update (self, _data6_->device, _data6_->release, NULL, NULL);
#line 1517 "FirmwareView.c"
	} else {
		GtkStack* _tmp1_;
		AdwLeaflet* _tmp2_;
#line 244 "../src/Views/FirmwareView.vala"
		_tmp1_ = self->priv->stack;
#line 244 "../src/Views/FirmwareView.vala"
		_tmp2_ = self->priv->deck;
#line 244 "../src/Views/FirmwareView.vala"
		gtk_stack_set_visible_child (_tmp1_, (GtkWidget*) _tmp2_);
#line 245 "../src/Views/FirmwareView.vala"
		return;
#line 1529 "FirmwareView.c"
	}
}

static void
____lambda27__gtk_dialog_response (GtkDialog* _sender,
                                   gint response_id,
                                   gpointer self)
{
#line 239 "../src/Views/FirmwareView.vala"
	___lambda27_ (self, response_id);
#line 1540 "FirmwareView.c"
}

static gboolean
about_firmware_view_update_co (AboutFirmwareViewUpdateData* _data_)
{
#line 226 "../src/Views/FirmwareView.vala"
	switch (_data_->_state_) {
#line 226 "../src/Views/FirmwareView.vala"
		case 0:
#line 1550 "FirmwareView.c"
		goto _state_0;
#line 226 "../src/Views/FirmwareView.vala"
		case 1:
#line 1554 "FirmwareView.c"
		goto _state_1;
		default:
#line 226 "../src/Views/FirmwareView.vala"
		g_assert_not_reached ();
#line 1559 "FirmwareView.c"
	}
	_state_0:
#line 226 "../src/Views/FirmwareView.vala"
	_data_->_data6_ = g_slice_new0 (Block6Data);
#line 226 "../src/Views/FirmwareView.vala"
	_data_->_data6_->_ref_count_ = 1;
#line 226 "../src/Views/FirmwareView.vala"
	_data_->_data6_->self = g_object_ref (_data_->self);
#line 226 "../src/Views/FirmwareView.vala"
	_g_object_unref0 (_data_->_data6_->device);
#line 226 "../src/Views/FirmwareView.vala"
	_data_->_data6_->device = _data_->device;
#line 226 "../src/Views/FirmwareView.vala"
	_g_object_unref0 (_data_->_data6_->release);
#line 226 "../src/Views/FirmwareView.vala"
	_data_->_data6_->release = _data_->release;
#line 226 "../src/Views/FirmwareView.vala"
	_data_->_data6_->_async_data_ = _data_;
#line 227 "../src/Views/FirmwareView.vala"
	_data_->_tmp0_ = _data_->self->priv->progress_alert_view;
#line 227 "../src/Views/FirmwareView.vala"
	_data_->_tmp1_ = fwupd_device_get_name (_data_->_data6_->device);
#line 227 "../src/Views/FirmwareView.vala"
	_data_->_tmp2_ = g_strdup_printf (_ ("“%s” is being updated"), _data_->_tmp1_);
#line 227 "../src/Views/FirmwareView.vala"
	_data_->_tmp3_ = _data_->_tmp2_;
#line 227 "../src/Views/FirmwareView.vala"
	granite_placeholder_set_title (_data_->_tmp0_, _data_->_tmp3_);
#line 227 "../src/Views/FirmwareView.vala"
	_g_free0 (_data_->_tmp3_);
#line 228 "../src/Views/FirmwareView.vala"
	_data_->_tmp4_ = _data_->self->priv->stack;
#line 228 "../src/Views/FirmwareView.vala"
	_data_->_tmp5_ = _data_->self->priv->progress_alert_view;
#line 228 "../src/Views/FirmwareView.vala"
	gtk_stack_set_visible_child (_data_->_tmp4_, (GtkWidget*) _data_->_tmp5_);
#line 230 "../src/Views/FirmwareView.vala"
	_data_->_tmp6_ = fwupd_release_get_detach_caption (_data_->_data6_->release);
#line 230 "../src/Views/FirmwareView.vala"
	_data_->detach_caption = _data_->_tmp6_;
#line 231 "../src/Views/FirmwareView.vala"
	_data_->_tmp7_ = _data_->detach_caption;
#line 231 "../src/Views/FirmwareView.vala"
	if (_data_->_tmp7_ != NULL) {
#line 231 "../src/Views/FirmwareView.vala"
		_data_->_data7_ = g_slice_new0 (Block7Data);
#line 231 "../src/Views/FirmwareView.vala"
		_data_->_data7_->_ref_count_ = 1;
#line 231 "../src/Views/FirmwareView.vala"
		_data_->_data7_->_data6_ = block6_data_ref (_data_->_data6_);
#line 232 "../src/Views/FirmwareView.vala"
		_data_->_tmp8_ = fwupd_release_get_detach_image (_data_->_data6_->release);
#line 232 "../src/Views/FirmwareView.vala"
		_data_->_tmp9_ = g_strdup (_data_->_tmp8_);
#line 232 "../src/Views/FirmwareView.vala"
		_data_->detach_image = _data_->_tmp9_;
#line 234 "../src/Views/FirmwareView.vala"
		_data_->_tmp10_ = _data_->detach_image;
#line 234 "../src/Views/FirmwareView.vala"
		if (_data_->_tmp10_ != NULL) {
#line 235 "../src/Views/FirmwareView.vala"
			_data_->_tmp11_ = _data_->detach_image;
#line 235 "../src/Views/FirmwareView.vala"
			_data_->_state_ = 1;
#line 235 "../src/Views/FirmwareView.vala"
			about_firmware_view_download_file (_data_->self, _data_->_data6_->device, _data_->_tmp11_, about_firmware_view_update_ready, _data_);
#line 235 "../src/Views/FirmwareView.vala"
			return FALSE;
#line 1628 "FirmwareView.c"
			_state_1:
#line 235 "../src/Views/FirmwareView.vala"
			_data_->_tmp12_ = about_firmware_view_download_file_finish (_data_->self, _data_->_res_);
#line 235 "../src/Views/FirmwareView.vala"
			_g_free0 (_data_->detach_image);
#line 235 "../src/Views/FirmwareView.vala"
			_data_->detach_image = _data_->_tmp12_;
#line 1636 "FirmwareView.c"
		}
#line 238 "../src/Views/FirmwareView.vala"
		_data_->_tmp13_ = _data_->detach_caption;
#line 238 "../src/Views/FirmwareView.vala"
		_data_->_tmp14_ = _data_->detach_image;
#line 238 "../src/Views/FirmwareView.vala"
		_data_->_tmp15_ = about_firmware_view_show_details_dialog (_data_->self, _data_->_data6_->device, _data_->_tmp13_, _data_->_tmp14_);
#line 238 "../src/Views/FirmwareView.vala"
		_data_->_data7_->details_dialog = _data_->_tmp15_;
#line 239 "../src/Views/FirmwareView.vala"
		_data_->_tmp16_ = _data_->_data7_->details_dialog;
#line 239 "../src/Views/FirmwareView.vala"
		g_signal_connect_data ((GtkDialog*) _data_->_tmp16_, "response", (GCallback) ____lambda27__gtk_dialog_response, block7_data_ref (_data_->_data7_), (GClosureNotify) block7_data_unref, 0);
#line 249 "../src/Views/FirmwareView.vala"
		_data_->_tmp17_ = _data_->_data7_->details_dialog;
#line 249 "../src/Views/FirmwareView.vala"
		gtk_window_present ((GtkWindow*) _data_->_tmp17_);
#line 231 "../src/Views/FirmwareView.vala"
		_g_free0 (_data_->detach_image);
#line 231 "../src/Views/FirmwareView.vala"
		block7_data_unref (_data_->_data7_);
#line 231 "../src/Views/FirmwareView.vala"
		_data_->_data7_ = NULL;
#line 1660 "FirmwareView.c"
	} else {
#line 251 "../src/Views/FirmwareView.vala"
		about_firmware_view_continue_update (_data_->self, _data_->_data6_->device, _data_->_data6_->release, NULL, NULL);
#line 1664 "FirmwareView.c"
	}
#line 226 "../src/Views/FirmwareView.vala"
	block6_data_unref (_data_->_data6_);
#line 226 "../src/Views/FirmwareView.vala"
	_data_->_data6_ = NULL;
#line 226 "../src/Views/FirmwareView.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 226 "../src/Views/FirmwareView.vala"
	if (_data_->_state_ != 0) {
#line 226 "../src/Views/FirmwareView.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 226 "../src/Views/FirmwareView.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1678 "FirmwareView.c"
		}
	}
#line 226 "../src/Views/FirmwareView.vala"
	g_object_unref (_data_->_async_result);
#line 226 "../src/Views/FirmwareView.vala"
	return FALSE;
#line 1685 "FirmwareView.c"
}

static void
about_firmware_view_continue_update_data_free (gpointer _data)
{
	AboutFirmwareViewContinueUpdateData* _data_;
	_data_ = _data;
#line 22 "../src/Views/FirmwareView.vala"
	_g_object_unref0 (_data_->device);
#line 22 "../src/Views/FirmwareView.vala"
	_g_object_unref0 (_data_->release);
#line 22 "../src/Views/FirmwareView.vala"
	_g_object_unref0 (_data_->self);
#line 22 "../src/Views/FirmwareView.vala"
	g_slice_free (AboutFirmwareViewContinueUpdateData, _data_);
#line 1701 "FirmwareView.c"
}

static void
about_firmware_view_continue_update (AboutFirmwareView* self,
                                     FwupdDevice* device,
                                     FwupdRelease* release,
                                     GAsyncReadyCallback _callback_,
                                     gpointer _user_data_)
{
	AboutFirmwareViewContinueUpdateData* _data_;
	AboutFirmwareView* _tmp0_;
	FwupdDevice* _tmp1_;
	FwupdRelease* _tmp2_;
#line 22 "../src/Views/FirmwareView.vala"
	g_return_if_fail (self != NULL);
#line 22 "../src/Views/FirmwareView.vala"
	g_return_if_fail (device != NULL);
#line 22 "../src/Views/FirmwareView.vala"
	g_return_if_fail (release != NULL);
#line 22 "../src/Views/FirmwareView.vala"
	_data_ = g_slice_new0 (AboutFirmwareViewContinueUpdateData);
#line 22 "../src/Views/FirmwareView.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 22 "../src/Views/FirmwareView.vala"
	g_task_set_task_data (_data_->_async_result, _data_, about_firmware_view_continue_update_data_free);
#line 22 "../src/Views/FirmwareView.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 22 "../src/Views/FirmwareView.vala"
	_data_->self = _tmp0_;
#line 22 "../src/Views/FirmwareView.vala"
	_tmp1_ = _g_object_ref0 (device);
#line 22 "../src/Views/FirmwareView.vala"
	_g_object_unref0 (_data_->device);
#line 22 "../src/Views/FirmwareView.vala"
	_data_->device = _tmp1_;
#line 22 "../src/Views/FirmwareView.vala"
	_tmp2_ = _g_object_ref0 (release);
#line 22 "../src/Views/FirmwareView.vala"
	_g_object_unref0 (_data_->release);
#line 22 "../src/Views/FirmwareView.vala"
	_data_->release = _tmp2_;
#line 22 "../src/Views/FirmwareView.vala"
	about_firmware_view_continue_update_co (_data_);
#line 1745 "FirmwareView.c"
}

static void
about_firmware_view_continue_update_finish (AboutFirmwareView* self,
                                            GAsyncResult* _res_)
{
	AboutFirmwareViewContinueUpdateData* _data_;
#line 22 "../src/Views/FirmwareView.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1755 "FirmwareView.c"
}

static void
about_firmware_view_continue_update_ready (GObject* source_object,
                                           GAsyncResult* _res_,
                                           gpointer _user_data_)
{
	AboutFirmwareViewContinueUpdateData* _data_;
#line 256 "../src/Views/FirmwareView.vala"
	_data_ = _user_data_;
#line 256 "../src/Views/FirmwareView.vala"
	_data_->_source_object_ = source_object;
#line 256 "../src/Views/FirmwareView.vala"
	_data_->_res_ = _res_;
#line 256 "../src/Views/FirmwareView.vala"
	about_firmware_view_continue_update_co (_data_);
#line 1772 "FirmwareView.c"
}

static gboolean
about_firmware_view_continue_update_co (AboutFirmwareViewContinueUpdateData* _data_)
{
#line 255 "../src/Views/FirmwareView.vala"
	switch (_data_->_state_) {
#line 255 "../src/Views/FirmwareView.vala"
		case 0:
#line 1782 "FirmwareView.c"
		goto _state_0;
#line 255 "../src/Views/FirmwareView.vala"
		case 1:
#line 1786 "FirmwareView.c"
		goto _state_1;
#line 255 "../src/Views/FirmwareView.vala"
		case 2:
#line 1790 "FirmwareView.c"
		goto _state_2;
		default:
#line 255 "../src/Views/FirmwareView.vala"
		g_assert_not_reached ();
#line 1795 "FirmwareView.c"
	}
	_state_0:
#line 256 "../src/Views/FirmwareView.vala"
	_data_->_tmp0_ = fwupd_release_get_uri (_data_->release);
#line 256 "../src/Views/FirmwareView.vala"
	_data_->_state_ = 1;
#line 256 "../src/Views/FirmwareView.vala"
	about_firmware_view_download_file (_data_->self, _data_->device, _data_->_tmp0_, about_firmware_view_continue_update_ready, _data_);
#line 256 "../src/Views/FirmwareView.vala"
	return FALSE;
#line 1806 "FirmwareView.c"
	_state_1:
#line 256 "../src/Views/FirmwareView.vala"
	_data_->_tmp1_ = about_firmware_view_download_file_finish (_data_->self, _data_->_res_);
#line 256 "../src/Views/FirmwareView.vala"
	_data_->path = _data_->_tmp1_;
#line 1812 "FirmwareView.c"
	{
#line 259 "../src/Views/FirmwareView.vala"
		_data_->install_flags = FWUPD_INSTALL_FLAG_NONE;
#line 260 "../src/Views/FirmwareView.vala"
		if (fwupd_device_has_flag (_data_->device, (FwupdDeviceFlags) FWUPD_DEVICE_FLAG_ONLY_OFFLINE)) {
#line 261 "../src/Views/FirmwareView.vala"
			_data_->install_flags = FWUPD_INSTALL_FLAG_OFFLINE;
#line 1820 "FirmwareView.c"
		}
#line 264 "../src/Views/FirmwareView.vala"
		_data_->_tmp3_ = _data_->self->priv->fwupd_client;
#line 264 "../src/Views/FirmwareView.vala"
		_data_->_tmp4_ = fwupd_device_get_id (_data_->device);
#line 264 "../src/Views/FirmwareView.vala"
		_data_->_tmp5_ = _data_->path;
#line 264 "../src/Views/FirmwareView.vala"
		_data_->_state_ = 2;
#line 264 "../src/Views/FirmwareView.vala"
		about_firmware_client_install (_data_->_tmp3_, _data_->_tmp4_, _data_->_tmp5_, _data_->install_flags, about_firmware_view_continue_update_ready, _data_);
#line 264 "../src/Views/FirmwareView.vala"
		return FALSE;
#line 1834 "FirmwareView.c"
		_state_2:
#line 264 "../src/Views/FirmwareView.vala"
		_data_->_tmp2_ = about_firmware_client_install_finish (_data_->_res_, &_data_->_inner_error0_);
#line 264 "../src/Views/FirmwareView.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1840 "FirmwareView.c"
			goto __catch0_g_error;
		}
#line 264 "../src/Views/FirmwareView.vala"
		if (_data_->_tmp2_) {
#line 265 "../src/Views/FirmwareView.vala"
			if (fwupd_device_has_flag (_data_->device, (FwupdDeviceFlags) FWUPD_DEVICE_FLAG_NEEDS_REBOOT)) {
#line 266 "../src/Views/FirmwareView.vala"
				about_firmware_view_show_reboot_dialog (_data_->self);
#line 1849 "FirmwareView.c"
			} else {
#line 267 "../src/Views/FirmwareView.vala"
				if (fwupd_device_has_flag (_data_->device, (FwupdDeviceFlags) FWUPD_DEVICE_FLAG_NEEDS_SHUTDOWN)) {
#line 268 "../src/Views/FirmwareView.vala"
					about_firmware_view_show_shutdown_dialog (_data_->self);
#line 1855 "FirmwareView.c"
				}
			}
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 258 "../src/Views/FirmwareView.vala"
		_data_->e = _data_->_inner_error0_;
#line 258 "../src/Views/FirmwareView.vala"
		_data_->_inner_error0_ = NULL;
#line 272 "../src/Views/FirmwareView.vala"
		_data_->_tmp6_ = _data_->e;
#line 272 "../src/Views/FirmwareView.vala"
		_data_->_tmp7_ = _data_->_tmp6_->message;
#line 272 "../src/Views/FirmwareView.vala"
		about_firmware_view_show_error_dialog (_data_->self, _data_->device, _data_->_tmp7_);
#line 258 "../src/Views/FirmwareView.vala"
		_g_error_free0 (_data_->e);
#line 1875 "FirmwareView.c"
	}
	__finally0:
#line 258 "../src/Views/FirmwareView.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 258 "../src/Views/FirmwareView.vala"
		_g_free0 (_data_->path);
#line 258 "../src/Views/FirmwareView.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 258 "../src/Views/FirmwareView.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 258 "../src/Views/FirmwareView.vala"
		g_object_unref (_data_->_async_result);
#line 258 "../src/Views/FirmwareView.vala"
		return FALSE;
#line 1890 "FirmwareView.c"
	}
#line 275 "../src/Views/FirmwareView.vala"
	_data_->_tmp8_ = _data_->self->priv->stack;
#line 275 "../src/Views/FirmwareView.vala"
	_data_->_tmp9_ = _data_->self->priv->deck;
#line 275 "../src/Views/FirmwareView.vala"
	gtk_stack_set_visible_child (_data_->_tmp8_, (GtkWidget*) _data_->_tmp9_);
#line 276 "../src/Views/FirmwareView.vala"
	about_firmware_view_update_list_view (_data_->self, NULL, NULL);
#line 255 "../src/Views/FirmwareView.vala"
	_g_free0 (_data_->path);
#line 255 "../src/Views/FirmwareView.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 255 "../src/Views/FirmwareView.vala"
	if (_data_->_state_ != 0) {
#line 255 "../src/Views/FirmwareView.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 255 "../src/Views/FirmwareView.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1910 "FirmwareView.c"
		}
	}
#line 255 "../src/Views/FirmwareView.vala"
	g_object_unref (_data_->_async_result);
#line 255 "../src/Views/FirmwareView.vala"
	return FALSE;
#line 1917 "FirmwareView.c"
}

static void
about_firmware_view_download_file_data_free (gpointer _data)
{
	AboutFirmwareViewDownloadFileData* _data_;
	_data_ = _data;
#line 22 "../src/Views/FirmwareView.vala"
	_g_object_unref0 (_data_->device);
#line 22 "../src/Views/FirmwareView.vala"
	_g_free0 (_data_->uri);
#line 22 "../src/Views/FirmwareView.vala"
	_g_free0 (_data_->result);
#line 22 "../src/Views/FirmwareView.vala"
	_g_object_unref0 (_data_->self);
#line 22 "../src/Views/FirmwareView.vala"
	g_slice_free (AboutFirmwareViewDownloadFileData, _data_);
#line 1935 "FirmwareView.c"
}

static void
about_firmware_view_download_file (AboutFirmwareView* self,
                                   FwupdDevice* device,
                                   const gchar* uri,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_)
{
	AboutFirmwareViewDownloadFileData* _data_;
	AboutFirmwareView* _tmp0_;
	FwupdDevice* _tmp1_;
	gchar* _tmp2_;
#line 22 "../src/Views/FirmwareView.vala"
	g_return_if_fail (self != NULL);
#line 22 "../src/Views/FirmwareView.vala"
	g_return_if_fail (device != NULL);
#line 22 "../src/Views/FirmwareView.vala"
	g_return_if_fail (uri != NULL);
#line 22 "../src/Views/FirmwareView.vala"
	_data_ = g_slice_new0 (AboutFirmwareViewDownloadFileData);
#line 22 "../src/Views/FirmwareView.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 22 "../src/Views/FirmwareView.vala"
	g_task_set_task_data (_data_->_async_result, _data_, about_firmware_view_download_file_data_free);
#line 22 "../src/Views/FirmwareView.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 22 "../src/Views/FirmwareView.vala"
	_data_->self = _tmp0_;
#line 22 "../src/Views/FirmwareView.vala"
	_tmp1_ = _g_object_ref0 (device);
#line 22 "../src/Views/FirmwareView.vala"
	_g_object_unref0 (_data_->device);
#line 22 "../src/Views/FirmwareView.vala"
	_data_->device = _tmp1_;
#line 22 "../src/Views/FirmwareView.vala"
	_tmp2_ = g_strdup (uri);
#line 22 "../src/Views/FirmwareView.vala"
	_g_free0 (_data_->uri);
#line 22 "../src/Views/FirmwareView.vala"
	_data_->uri = _tmp2_;
#line 22 "../src/Views/FirmwareView.vala"
	about_firmware_view_download_file_co (_data_);
#line 1979 "FirmwareView.c"
}

static gchar*
about_firmware_view_download_file_finish (AboutFirmwareView* self,
                                          GAsyncResult* _res_)
{
	gchar* result;
	AboutFirmwareViewDownloadFileData* _data_;
#line 22 "../src/Views/FirmwareView.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 22 "../src/Views/FirmwareView.vala"
	result = _data_->result;
#line 22 "../src/Views/FirmwareView.vala"
	_data_->result = NULL;
#line 22 "../src/Views/FirmwareView.vala"
	return result;
#line 1996 "FirmwareView.c"
}

static void
___lambda26_ (AboutFirmwareView* self,
              gint64 current_num_bytes,
              gint64 total_num_bytes)
{
}

static void
____lambda26__gfile_progress_callback (gint64 current_num_bytes,
                                       gint64 total_num_bytes,
                                       gpointer self)
{
#line 286 "../src/Views/FirmwareView.vala"
	___lambda26_ ((AboutFirmwareView*) self, current_num_bytes, total_num_bytes);
#line 2013 "FirmwareView.c"
}

static void
about_firmware_view_download_file_ready (GObject* source_object,
                                         GAsyncResult* _res_,
                                         gpointer _user_data_)
{
	AboutFirmwareViewDownloadFileData* _data_;
#line 286 "../src/Views/FirmwareView.vala"
	_data_ = _user_data_;
#line 286 "../src/Views/FirmwareView.vala"
	_data_->_source_object_ = source_object;
#line 286 "../src/Views/FirmwareView.vala"
	_data_->_res_ = _res_;
#line 286 "../src/Views/FirmwareView.vala"
	about_firmware_view_download_file_co (_data_);
#line 2030 "FirmwareView.c"
}

static gboolean
about_firmware_view_download_file_co (AboutFirmwareViewDownloadFileData* _data_)
{
#line 279 "../src/Views/FirmwareView.vala"
	switch (_data_->_state_) {
#line 279 "../src/Views/FirmwareView.vala"
		case 0:
#line 2040 "FirmwareView.c"
		goto _state_0;
#line 279 "../src/Views/FirmwareView.vala"
		case 1:
#line 2044 "FirmwareView.c"
		goto _state_1;
		default:
#line 279 "../src/Views/FirmwareView.vala"
		g_assert_not_reached ();
#line 2049 "FirmwareView.c"
	}
	_state_0:
#line 280 "../src/Views/FirmwareView.vala"
	_data_->_tmp0_ = g_file_new_for_uri (_data_->uri);
#line 280 "../src/Views/FirmwareView.vala"
	_data_->server_file = _data_->_tmp0_;
#line 281 "../src/Views/FirmwareView.vala"
	_data_->_tmp1_ = g_get_tmp_dir ();
#line 281 "../src/Views/FirmwareView.vala"
	_data_->_tmp2_ = _data_->server_file;
#line 281 "../src/Views/FirmwareView.vala"
	_data_->_tmp3_ = g_file_get_basename (_data_->_tmp2_);
#line 281 "../src/Views/FirmwareView.vala"
	_data_->_tmp4_ = _data_->_tmp3_;
#line 281 "../src/Views/FirmwareView.vala"
	_data_->_tmp5_ = g_build_filename (_data_->_tmp1_, _data_->_tmp4_, NULL);
#line 281 "../src/Views/FirmwareView.vala"
	_data_->_tmp6_ = _data_->_tmp5_;
#line 281 "../src/Views/FirmwareView.vala"
	_g_free0 (_data_->_tmp4_);
#line 281 "../src/Views/FirmwareView.vala"
	_data_->path = _data_->_tmp6_;
#line 282 "../src/Views/FirmwareView.vala"
	_data_->_tmp7_ = _data_->path;
#line 282 "../src/Views/FirmwareView.vala"
	_data_->_tmp8_ = g_file_new_for_path (_data_->_tmp7_);
#line 282 "../src/Views/FirmwareView.vala"
	_data_->local_file = _data_->_tmp8_;
#line 2078 "FirmwareView.c"
	{
#line 286 "../src/Views/FirmwareView.vala"
		_data_->_tmp10_ = _data_->server_file;
#line 286 "../src/Views/FirmwareView.vala"
		_data_->_tmp11_ = _data_->local_file;
#line 286 "../src/Views/FirmwareView.vala"
		_data_->_state_ = 1;
#line 286 "../src/Views/FirmwareView.vala"
		g_file_copy_async (_data_->_tmp10_, _data_->_tmp11_, G_FILE_COPY_OVERWRITE, G_PRIORITY_DEFAULT, NULL, ____lambda26__gfile_progress_callback, _data_->self, about_firmware_view_download_file_ready, _data_);
#line 286 "../src/Views/FirmwareView.vala"
		return FALSE;
#line 2090 "FirmwareView.c"
		_state_1:
#line 286 "../src/Views/FirmwareView.vala"
		_data_->_tmp9_ = g_file_copy_finish (_data_->_tmp10_, _data_->_res_, &_data_->_inner_error0_);
#line 286 "../src/Views/FirmwareView.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2096 "FirmwareView.c"
			goto __catch0_g_error;
		}
#line 286 "../src/Views/FirmwareView.vala"
		_data_->_result_ = _data_->_tmp9_;
#line 2101 "FirmwareView.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 285 "../src/Views/FirmwareView.vala"
		_data_->e = _data_->_inner_error0_;
#line 285 "../src/Views/FirmwareView.vala"
		_data_->_inner_error0_ = NULL;
#line 290 "../src/Views/FirmwareView.vala"
		_data_->_tmp12_ = _data_->e;
#line 290 "../src/Views/FirmwareView.vala"
		_data_->_tmp13_ = _data_->_tmp12_->message;
#line 290 "../src/Views/FirmwareView.vala"
		_data_->_tmp14_ = g_strdup_printf ("Could not download file: %s", _data_->_tmp13_);
#line 290 "../src/Views/FirmwareView.vala"
		_data_->_tmp15_ = _data_->_tmp14_;
#line 290 "../src/Views/FirmwareView.vala"
		about_firmware_view_show_error_dialog (_data_->self, _data_->device, _data_->_tmp15_);
#line 290 "../src/Views/FirmwareView.vala"
		_g_free0 (_data_->_tmp15_);
#line 291 "../src/Views/FirmwareView.vala"
		_data_->result = NULL;
#line 291 "../src/Views/FirmwareView.vala"
		_g_error_free0 (_data_->e);
#line 291 "../src/Views/FirmwareView.vala"
		_g_object_unref0 (_data_->local_file);
#line 291 "../src/Views/FirmwareView.vala"
		_g_free0 (_data_->path);
#line 291 "../src/Views/FirmwareView.vala"
		_g_object_unref0 (_data_->server_file);
#line 291 "../src/Views/FirmwareView.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 291 "../src/Views/FirmwareView.vala"
		if (_data_->_state_ != 0) {
#line 291 "../src/Views/FirmwareView.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 291 "../src/Views/FirmwareView.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2140 "FirmwareView.c"
			}
		}
#line 291 "../src/Views/FirmwareView.vala"
		g_object_unref (_data_->_async_result);
#line 291 "../src/Views/FirmwareView.vala"
		return FALSE;
#line 2147 "FirmwareView.c"
	}
	__finally0:
#line 285 "../src/Views/FirmwareView.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 285 "../src/Views/FirmwareView.vala"
		_g_object_unref0 (_data_->local_file);
#line 285 "../src/Views/FirmwareView.vala"
		_g_free0 (_data_->path);
#line 285 "../src/Views/FirmwareView.vala"
		_g_object_unref0 (_data_->server_file);
#line 285 "../src/Views/FirmwareView.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 285 "../src/Views/FirmwareView.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 285 "../src/Views/FirmwareView.vala"
		g_object_unref (_data_->_async_result);
#line 285 "../src/Views/FirmwareView.vala"
		return FALSE;
#line 2166 "FirmwareView.c"
	}
#line 294 "../src/Views/FirmwareView.vala"
	if (!_data_->_result_) {
#line 295 "../src/Views/FirmwareView.vala"
		_data_->_tmp16_ = g_strdup_printf ("Download of %s was not successful", _data_->uri);
#line 295 "../src/Views/FirmwareView.vala"
		_data_->_tmp17_ = _data_->_tmp16_;
#line 295 "../src/Views/FirmwareView.vala"
		about_firmware_view_show_error_dialog (_data_->self, _data_->device, _data_->_tmp17_);
#line 295 "../src/Views/FirmwareView.vala"
		_g_free0 (_data_->_tmp17_);
#line 296 "../src/Views/FirmwareView.vala"
		_data_->result = NULL;
#line 296 "../src/Views/FirmwareView.vala"
		_g_object_unref0 (_data_->local_file);
#line 296 "../src/Views/FirmwareView.vala"
		_g_free0 (_data_->path);
#line 296 "../src/Views/FirmwareView.vala"
		_g_object_unref0 (_data_->server_file);
#line 296 "../src/Views/FirmwareView.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 296 "../src/Views/FirmwareView.vala"
		if (_data_->_state_ != 0) {
#line 296 "../src/Views/FirmwareView.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 296 "../src/Views/FirmwareView.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2194 "FirmwareView.c"
			}
		}
#line 296 "../src/Views/FirmwareView.vala"
		g_object_unref (_data_->_async_result);
#line 296 "../src/Views/FirmwareView.vala"
		return FALSE;
#line 2201 "FirmwareView.c"
	}
#line 299 "../src/Views/FirmwareView.vala"
	_data_->result = _data_->path;
#line 299 "../src/Views/FirmwareView.vala"
	_g_object_unref0 (_data_->local_file);
#line 299 "../src/Views/FirmwareView.vala"
	_g_object_unref0 (_data_->server_file);
#line 299 "../src/Views/FirmwareView.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 299 "../src/Views/FirmwareView.vala"
	if (_data_->_state_ != 0) {
#line 299 "../src/Views/FirmwareView.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 299 "../src/Views/FirmwareView.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2217 "FirmwareView.c"
		}
	}
#line 299 "../src/Views/FirmwareView.vala"
	g_object_unref (_data_->_async_result);
#line 299 "../src/Views/FirmwareView.vala"
	return FALSE;
#line 2224 "FirmwareView.c"
}

static gpointer
_g_ptr_array_ref0 (gpointer self)
{
#line 304 "../src/Views/FirmwareView.vala"
	return self ? g_ptr_array_ref (self) : NULL;
#line 2232 "FirmwareView.c"
}

static void
_gtk_window_destroy_gtk_dialog_response (GtkDialog* _sender,
                                         gint response_id,
                                         gpointer self)
{
#line 319 "../src/Views/FirmwareView.vala"
	gtk_window_destroy ((GtkWindow*) self);
#line 2242 "FirmwareView.c"
}

static void
about_firmware_view_show_error_dialog (AboutFirmwareView* self,
                                       FwupdDevice* device,
                                       const gchar* secondary_text)
{
	GThemedIcon* gicon = NULL;
	GThemedIcon* _tmp0_;
	GPtrArray* icons = NULL;
	GPtrArray* _tmp1_;
	GPtrArray* _tmp2_;
	GPtrArray* _tmp3_;
	gpointer* _tmp4_;
	gint _tmp4__length1;
	GraniteMessageDialog* message_dialog = NULL;
	GThemedIcon* _tmp8_;
	GThemedIcon* _tmp9_;
	GtkRoot* _tmp10_;
	GtkWindow* _tmp11_;
	GraniteMessageDialog* _tmp12_ = NULL;
#line 302 "../src/Views/FirmwareView.vala"
	g_return_if_fail (self != NULL);
#line 302 "../src/Views/FirmwareView.vala"
	g_return_if_fail (device != NULL);
#line 302 "../src/Views/FirmwareView.vala"
	g_return_if_fail (secondary_text != NULL);
#line 303 "../src/Views/FirmwareView.vala"
	_tmp0_ = (GThemedIcon*) g_themed_icon_new ("application-x-firmware");
#line 303 "../src/Views/FirmwareView.vala"
	gicon = _tmp0_;
#line 304 "../src/Views/FirmwareView.vala"
	_tmp1_ = fwupd_device_get_icons (device);
#line 304 "../src/Views/FirmwareView.vala"
	_tmp2_ = _g_ptr_array_ref0 (_tmp1_);
#line 304 "../src/Views/FirmwareView.vala"
	icons = _tmp2_;
#line 305 "../src/Views/FirmwareView.vala"
	_tmp3_ = icons;
#line 305 "../src/Views/FirmwareView.vala"
	_tmp4_ = _tmp3_->pdata;
#line 305 "../src/Views/FirmwareView.vala"
	_tmp4__length1 = _tmp3_->len;
#line 305 "../src/Views/FirmwareView.vala"
	if (_tmp4_ != NULL) {
#line 2288 "FirmwareView.c"
		GPtrArray* _tmp5_;
		gpointer* _tmp6_;
		gint _tmp6__length1;
		GThemedIcon* _tmp7_;
#line 306 "../src/Views/FirmwareView.vala"
		_tmp5_ = icons;
#line 306 "../src/Views/FirmwareView.vala"
		_tmp6_ = _tmp5_->pdata;
#line 306 "../src/Views/FirmwareView.vala"
		_tmp6__length1 = _tmp5_->len;
#line 306 "../src/Views/FirmwareView.vala"
		_tmp7_ = (GThemedIcon*) g_themed_icon_new_from_names (_tmp6_, _tmp6__length1);
#line 306 "../src/Views/FirmwareView.vala"
		_g_object_unref0 (gicon);
#line 306 "../src/Views/FirmwareView.vala"
		gicon = _tmp7_;
#line 2305 "FirmwareView.c"
	}
#line 309 "../src/Views/FirmwareView.vala"
	_tmp8_ = gicon;
#line 309 "../src/Views/FirmwareView.vala"
	_tmp9_ = (GThemedIcon*) g_themed_icon_new ("dialog-error");
#line 309 "../src/Views/FirmwareView.vala"
	_tmp10_ = gtk_widget_get_root ((GtkWidget*) self);
#line 309 "../src/Views/FirmwareView.vala"
	_tmp11_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, gtk_window_get_type (), GtkWindow));
#line 309 "../src/Views/FirmwareView.vala"
	_tmp12_ = granite_message_dialog_new (_ ("Failed to install firmware release"), secondary_text, (GIcon*) _tmp8_, GTK_BUTTONS_CLOSE);
#line 309 "../src/Views/FirmwareView.vala"
	granite_message_dialog_set_badge_icon (_tmp12_, (GIcon*) _tmp9_);
#line 309 "../src/Views/FirmwareView.vala"
	_g_object_unref0 (_tmp9_);
#line 309 "../src/Views/FirmwareView.vala"
	gtk_window_set_transient_for ((GtkWindow*) _tmp12_, _tmp11_);
#line 309 "../src/Views/FirmwareView.vala"
	_g_object_unref0 (_tmp11_);
#line 309 "../src/Views/FirmwareView.vala"
	g_object_ref_sink (_tmp12_);
#line 309 "../src/Views/FirmwareView.vala"
	message_dialog = _tmp12_;
#line 319 "../src/Views/FirmwareView.vala"
	g_signal_connect_object ((GtkDialog*) message_dialog, "response", (GCallback) _gtk_window_destroy_gtk_dialog_response, (GtkWindow*) message_dialog, 0);
#line 320 "../src/Views/FirmwareView.vala"
	gtk_window_present ((GtkWindow*) message_dialog);
#line 302 "../src/Views/FirmwareView.vala"
	_g_object_unref0 (message_dialog);
#line 302 "../src/Views/FirmwareView.vala"
	_g_ptr_array_unref0 (icons);
#line 302 "../src/Views/FirmwareView.vala"
	_g_object_unref0 (gicon);
#line 2339 "FirmwareView.c"
}

static GraniteMessageDialog*
about_firmware_view_show_details_dialog (AboutFirmwareView* self,
                                         FwupdDevice* device,
                                         const gchar* detach_caption,
                                         const gchar* detach_image)
{
	GThemedIcon* gicon = NULL;
	GThemedIcon* _tmp0_;
	GPtrArray* icons = NULL;
	GPtrArray* _tmp1_;
	GPtrArray* _tmp2_;
	GPtrArray* _tmp3_;
	gpointer* _tmp4_;
	gint _tmp4__length1;
	GraniteMessageDialog* message_dialog = NULL;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	GThemedIcon* _tmp11_;
	GThemedIcon* _tmp12_;
	GtkRoot* _tmp13_;
	GtkWindow* _tmp14_;
	GraniteMessageDialog* _tmp15_ = NULL;
	GraniteMessageDialog* _tmp16_;
	GtkButton* suggested_button = NULL;
	GraniteMessageDialog* _tmp17_;
	GtkWidget* _tmp18_;
	GtkButton* _tmp19_;
	GtkButton* _tmp20_;
	GraniteMessageDialog* result;
#line 323 "../src/Views/FirmwareView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 323 "../src/Views/FirmwareView.vala"
	g_return_val_if_fail (device != NULL, NULL);
#line 323 "../src/Views/FirmwareView.vala"
	g_return_val_if_fail (detach_caption != NULL, NULL);
#line 324 "../src/Views/FirmwareView.vala"
	_tmp0_ = (GThemedIcon*) g_themed_icon_new ("application-x-firmware");
#line 324 "../src/Views/FirmwareView.vala"
	gicon = _tmp0_;
#line 325 "../src/Views/FirmwareView.vala"
	_tmp1_ = fwupd_device_get_icons (device);
#line 325 "../src/Views/FirmwareView.vala"
	_tmp2_ = _g_ptr_array_ref0 (_tmp1_);
#line 325 "../src/Views/FirmwareView.vala"
	icons = _tmp2_;
#line 326 "../src/Views/FirmwareView.vala"
	_tmp3_ = icons;
#line 326 "../src/Views/FirmwareView.vala"
	_tmp4_ = _tmp3_->pdata;
#line 326 "../src/Views/FirmwareView.vala"
	_tmp4__length1 = _tmp3_->len;
#line 326 "../src/Views/FirmwareView.vala"
	if (_tmp4_ != NULL) {
#line 2396 "FirmwareView.c"
		GPtrArray* _tmp5_;
		gpointer* _tmp6_;
		gint _tmp6__length1;
		GThemedIcon* _tmp7_;
#line 327 "../src/Views/FirmwareView.vala"
		_tmp5_ = icons;
#line 327 "../src/Views/FirmwareView.vala"
		_tmp6_ = _tmp5_->pdata;
#line 327 "../src/Views/FirmwareView.vala"
		_tmp6__length1 = _tmp5_->len;
#line 327 "../src/Views/FirmwareView.vala"
		_tmp7_ = (GThemedIcon*) g_themed_icon_new_from_names (_tmp6_, _tmp6__length1);
#line 327 "../src/Views/FirmwareView.vala"
		_g_object_unref0 (gicon);
#line 327 "../src/Views/FirmwareView.vala"
		gicon = _tmp7_;
#line 2413 "FirmwareView.c"
	}
#line 330 "../src/Views/FirmwareView.vala"
	_tmp8_ = fwupd_device_get_name (device);
#line 330 "../src/Views/FirmwareView.vala"
	_tmp9_ = g_strdup_printf (_ ("“%s” needs to manually be put in update mode"), _tmp8_);
#line 330 "../src/Views/FirmwareView.vala"
	_tmp10_ = _tmp9_;
#line 330 "../src/Views/FirmwareView.vala"
	_tmp11_ = gicon;
#line 330 "../src/Views/FirmwareView.vala"
	_tmp12_ = (GThemedIcon*) g_themed_icon_new ("dialog-information");
#line 330 "../src/Views/FirmwareView.vala"
	_tmp13_ = gtk_widget_get_root ((GtkWidget*) self);
#line 330 "../src/Views/FirmwareView.vala"
	_tmp14_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, gtk_window_get_type (), GtkWindow));
#line 330 "../src/Views/FirmwareView.vala"
	_tmp15_ = granite_message_dialog_new (_tmp10_, detach_caption, (GIcon*) _tmp11_, GTK_BUTTONS_CANCEL);
#line 330 "../src/Views/FirmwareView.vala"
	granite_message_dialog_set_badge_icon (_tmp15_, (GIcon*) _tmp12_);
#line 330 "../src/Views/FirmwareView.vala"
	_g_object_unref0 (_tmp12_);
#line 330 "../src/Views/FirmwareView.vala"
	gtk_window_set_transient_for ((GtkWindow*) _tmp15_, _tmp14_);
#line 330 "../src/Views/FirmwareView.vala"
	_g_object_unref0 (_tmp14_);
#line 330 "../src/Views/FirmwareView.vala"
	g_object_ref_sink (_tmp15_);
#line 330 "../src/Views/FirmwareView.vala"
	_tmp16_ = _tmp15_;
#line 330 "../src/Views/FirmwareView.vala"
	_g_free0 (_tmp10_);
#line 330 "../src/Views/FirmwareView.vala"
	message_dialog = _tmp16_;
#line 340 "../src/Views/FirmwareView.vala"
	_tmp17_ = message_dialog;
#line 340 "../src/Views/FirmwareView.vala"
	_tmp18_ = granite_dialog_add_button ((GraniteDialog*) _tmp17_, _ ("Continue"), (gint) GTK_RESPONSE_ACCEPT);
#line 340 "../src/Views/FirmwareView.vala"
	_tmp19_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, gtk_button_get_type (), GtkButton));
#line 340 "../src/Views/FirmwareView.vala"
	suggested_button = _tmp19_;
#line 341 "../src/Views/FirmwareView.vala"
	_tmp20_ = suggested_button;
#line 341 "../src/Views/FirmwareView.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp20_, GRANITE_STYLE_CLASS_SUGGESTED_ACTION);
#line 343 "../src/Views/FirmwareView.vala"
	if (detach_image != NULL) {
#line 2461 "FirmwareView.c"
		GtkImage* custom_widget = NULL;
		GtkImage* _tmp21_;
		GraniteMessageDialog* _tmp22_;
		GtkBox* _tmp23_;
		GtkBox* _tmp24_;
		GtkImage* _tmp25_;
#line 344 "../src/Views/FirmwareView.vala"
		_tmp21_ = (GtkImage*) gtk_image_new_from_file (detach_image);
#line 344 "../src/Views/FirmwareView.vala"
		g_object_ref_sink (_tmp21_);
#line 344 "../src/Views/FirmwareView.vala"
		custom_widget = _tmp21_;
#line 345 "../src/Views/FirmwareView.vala"
		_tmp22_ = message_dialog;
#line 345 "../src/Views/FirmwareView.vala"
		_tmp23_ = granite_message_dialog_get_custom_bin (_tmp22_);
#line 345 "../src/Views/FirmwareView.vala"
		_tmp24_ = _tmp23_;
#line 345 "../src/Views/FirmwareView.vala"
		_tmp25_ = custom_widget;
#line 345 "../src/Views/FirmwareView.vala"
		gtk_box_append (_tmp24_, (GtkWidget*) _tmp25_);
#line 343 "../src/Views/FirmwareView.vala"
		_g_object_unref0 (custom_widget);
#line 2486 "FirmwareView.c"
	}
#line 348 "../src/Views/FirmwareView.vala"
	result = message_dialog;
#line 348 "../src/Views/FirmwareView.vala"
	_g_object_unref0 (suggested_button);
#line 348 "../src/Views/FirmwareView.vala"
	_g_ptr_array_unref0 (icons);
#line 348 "../src/Views/FirmwareView.vala"
	_g_object_unref0 (gicon);
#line 348 "../src/Views/FirmwareView.vala"
	return result;
#line 2498 "FirmwareView.c"
}

static Block8Data*
block8_data_ref (Block8Data* _data8_)
{
#line 351 "../src/Views/FirmwareView.vala"
	g_atomic_int_inc (&_data8_->_ref_count_);
#line 351 "../src/Views/FirmwareView.vala"
	return _data8_;
#line 2508 "FirmwareView.c"
}

static void
block8_data_unref (void * _userdata_)
{
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
#line 351 "../src/Views/FirmwareView.vala"
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
#line 2518 "FirmwareView.c"
		AboutFirmwareView* self;
#line 351 "../src/Views/FirmwareView.vala"
		self = _data8_->self;
#line 351 "../src/Views/FirmwareView.vala"
		_g_object_unref0 (_data8_->message_dialog);
#line 351 "../src/Views/FirmwareView.vala"
		_g_object_unref0 (self);
#line 351 "../src/Views/FirmwareView.vala"
		g_slice_free (Block8Data, _data8_);
#line 2528 "FirmwareView.c"
	}
}

static void
__lambda28_ (Block8Data* _data8_,
             gint response)
{
	AboutFirmwareView* self;
#line 365 "../src/Views/FirmwareView.vala"
	self = _data8_->self;
#line 366 "../src/Views/FirmwareView.vala"
	if (response == ((gint) GTK_RESPONSE_ACCEPT)) {
#line 2541 "FirmwareView.c"
		AboutLoginManager* _tmp0_;
		AboutLoginManager* _tmp1_;
#line 367 "../src/Views/FirmwareView.vala"
		_tmp0_ = about_login_manager_get_instance ();
#line 367 "../src/Views/FirmwareView.vala"
		_tmp1_ = _tmp0_;
#line 367 "../src/Views/FirmwareView.vala"
		about_login_manager_reboot (_tmp1_);
#line 367 "../src/Views/FirmwareView.vala"
		_g_object_unref0 (_tmp1_);
#line 2552 "FirmwareView.c"
	}
#line 369 "../src/Views/FirmwareView.vala"
	gtk_window_destroy ((GtkWindow*) _data8_->message_dialog);
#line 2556 "FirmwareView.c"
}

static void
___lambda28__gtk_dialog_response (GtkDialog* _sender,
                                  gint response_id,
                                  gpointer self)
{
#line 365 "../src/Views/FirmwareView.vala"
	__lambda28_ (self, response_id);
#line 2566 "FirmwareView.c"
}

static void
about_firmware_view_show_reboot_dialog (AboutFirmwareView* self)
{
	Block8Data* _data8_;
	GThemedIcon* _tmp0_;
	GtkRoot* _tmp1_;
	GtkWindow* _tmp2_;
	GraniteMessageDialog* _tmp3_ = NULL;
	GtkButton* suggested_button = NULL;
	GtkWidget* _tmp4_;
	GtkButton* _tmp5_;
#line 351 "../src/Views/FirmwareView.vala"
	g_return_if_fail (self != NULL);
#line 351 "../src/Views/FirmwareView.vala"
	_data8_ = g_slice_new0 (Block8Data);
#line 351 "../src/Views/FirmwareView.vala"
	_data8_->_ref_count_ = 1;
#line 351 "../src/Views/FirmwareView.vala"
	_data8_->self = g_object_ref (self);
#line 352 "../src/Views/FirmwareView.vala"
	_tmp0_ = (GThemedIcon*) g_themed_icon_new ("system-reboot");
#line 352 "../src/Views/FirmwareView.vala"
	_tmp1_ = gtk_widget_get_root ((GtkWidget*) self);
#line 352 "../src/Views/FirmwareView.vala"
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_window_get_type (), GtkWindow));
#line 352 "../src/Views/FirmwareView.vala"
	_tmp3_ = granite_message_dialog_new_with_image_from_icon_name (_ ("An update requires the system to restart to complete"), _ ("This will close all open applications and restart this device."), "application-x-firmware", GTK_BUTTONS_CANCEL);
#line 352 "../src/Views/FirmwareView.vala"
	granite_message_dialog_set_badge_icon (_tmp3_, (GIcon*) _tmp0_);
#line 352 "../src/Views/FirmwareView.vala"
	_g_object_unref0 (_tmp0_);
#line 352 "../src/Views/FirmwareView.vala"
	gtk_window_set_transient_for ((GtkWindow*) _tmp3_, _tmp2_);
#line 352 "../src/Views/FirmwareView.vala"
	_g_object_unref0 (_tmp2_);
#line 352 "../src/Views/FirmwareView.vala"
	g_object_ref_sink (_tmp3_);
#line 352 "../src/Views/FirmwareView.vala"
	_data8_->message_dialog = _tmp3_;
#line 362 "../src/Views/FirmwareView.vala"
	_tmp4_ = granite_dialog_add_button ((GraniteDialog*) _data8_->message_dialog, _ ("Restart"), (gint) GTK_RESPONSE_ACCEPT);
#line 362 "../src/Views/FirmwareView.vala"
	_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_button_get_type (), GtkButton));
#line 362 "../src/Views/FirmwareView.vala"
	suggested_button = _tmp5_;
#line 363 "../src/Views/FirmwareView.vala"
	gtk_widget_add_css_class ((GtkWidget*) suggested_button, GRANITE_STYLE_CLASS_SUGGESTED_ACTION);
#line 365 "../src/Views/FirmwareView.vala"
	g_signal_connect_data ((GtkDialog*) _data8_->message_dialog, "response", (GCallback) ___lambda28__gtk_dialog_response, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
#line 372 "../src/Views/FirmwareView.vala"
	gtk_window_present ((GtkWindow*) _data8_->message_dialog);
#line 351 "../src/Views/FirmwareView.vala"
	_g_object_unref0 (suggested_button);
#line 351 "../src/Views/FirmwareView.vala"
	block8_data_unref (_data8_);
#line 351 "../src/Views/FirmwareView.vala"
	_data8_ = NULL;
#line 2626 "FirmwareView.c"
}

static Block9Data*
block9_data_ref (Block9Data* _data9_)
{
#line 375 "../src/Views/FirmwareView.vala"
	g_atomic_int_inc (&_data9_->_ref_count_);
#line 375 "../src/Views/FirmwareView.vala"
	return _data9_;
#line 2636 "FirmwareView.c"
}

static void
block9_data_unref (void * _userdata_)
{
	Block9Data* _data9_;
	_data9_ = (Block9Data*) _userdata_;
#line 375 "../src/Views/FirmwareView.vala"
	if (g_atomic_int_dec_and_test (&_data9_->_ref_count_)) {
#line 2646 "FirmwareView.c"
		AboutFirmwareView* self;
#line 375 "../src/Views/FirmwareView.vala"
		self = _data9_->self;
#line 375 "../src/Views/FirmwareView.vala"
		_g_object_unref0 (_data9_->message_dialog);
#line 375 "../src/Views/FirmwareView.vala"
		_g_object_unref0 (self);
#line 375 "../src/Views/FirmwareView.vala"
		g_slice_free (Block9Data, _data9_);
#line 2656 "FirmwareView.c"
	}
}

static void
__lambda29_ (Block9Data* _data9_,
             gint response)
{
	AboutFirmwareView* self;
#line 389 "../src/Views/FirmwareView.vala"
	self = _data9_->self;
#line 390 "../src/Views/FirmwareView.vala"
	if (response == ((gint) GTK_RESPONSE_ACCEPT)) {
#line 2669 "FirmwareView.c"
		AboutLoginManager* _tmp0_;
		AboutLoginManager* _tmp1_;
#line 391 "../src/Views/FirmwareView.vala"
		_tmp0_ = about_login_manager_get_instance ();
#line 391 "../src/Views/FirmwareView.vala"
		_tmp1_ = _tmp0_;
#line 391 "../src/Views/FirmwareView.vala"
		about_login_manager_shutdown (_tmp1_);
#line 391 "../src/Views/FirmwareView.vala"
		_g_object_unref0 (_tmp1_);
#line 2680 "FirmwareView.c"
	}
#line 393 "../src/Views/FirmwareView.vala"
	gtk_window_destroy ((GtkWindow*) _data9_->message_dialog);
#line 2684 "FirmwareView.c"
}

static void
___lambda29__gtk_dialog_response (GtkDialog* _sender,
                                  gint response_id,
                                  gpointer self)
{
#line 389 "../src/Views/FirmwareView.vala"
	__lambda29_ (self, response_id);
#line 2694 "FirmwareView.c"
}

static void
about_firmware_view_show_shutdown_dialog (AboutFirmwareView* self)
{
	Block9Data* _data9_;
	GThemedIcon* _tmp0_;
	GtkRoot* _tmp1_;
	GtkWindow* _tmp2_;
	GraniteMessageDialog* _tmp3_ = NULL;
	GtkButton* suggested_button = NULL;
	GtkWidget* _tmp4_;
	GtkButton* _tmp5_;
#line 375 "../src/Views/FirmwareView.vala"
	g_return_if_fail (self != NULL);
#line 375 "../src/Views/FirmwareView.vala"
	_data9_ = g_slice_new0 (Block9Data);
#line 375 "../src/Views/FirmwareView.vala"
	_data9_->_ref_count_ = 1;
#line 375 "../src/Views/FirmwareView.vala"
	_data9_->self = g_object_ref (self);
#line 376 "../src/Views/FirmwareView.vala"
	_tmp0_ = (GThemedIcon*) g_themed_icon_new ("system-shutdown");
#line 376 "../src/Views/FirmwareView.vala"
	_tmp1_ = gtk_widget_get_root ((GtkWidget*) self);
#line 376 "../src/Views/FirmwareView.vala"
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_window_get_type (), GtkWindow));
#line 376 "../src/Views/FirmwareView.vala"
	_tmp3_ = granite_message_dialog_new_with_image_from_icon_name (_ ("An update requires the system to shut down to complete"), _ ("This will close all open applications and turn off this device."), "application-x-firmware", GTK_BUTTONS_CANCEL);
#line 376 "../src/Views/FirmwareView.vala"
	granite_message_dialog_set_badge_icon (_tmp3_, (GIcon*) _tmp0_);
#line 376 "../src/Views/FirmwareView.vala"
	_g_object_unref0 (_tmp0_);
#line 376 "../src/Views/FirmwareView.vala"
	gtk_window_set_transient_for ((GtkWindow*) _tmp3_, _tmp2_);
#line 376 "../src/Views/FirmwareView.vala"
	_g_object_unref0 (_tmp2_);
#line 376 "../src/Views/FirmwareView.vala"
	g_object_ref_sink (_tmp3_);
#line 376 "../src/Views/FirmwareView.vala"
	_data9_->message_dialog = _tmp3_;
#line 386 "../src/Views/FirmwareView.vala"
	_tmp4_ = granite_dialog_add_button ((GraniteDialog*) _data9_->message_dialog, _ ("Shut Down"), (gint) GTK_RESPONSE_ACCEPT);
#line 386 "../src/Views/FirmwareView.vala"
	_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_button_get_type (), GtkButton));
#line 386 "../src/Views/FirmwareView.vala"
	suggested_button = _tmp5_;
#line 387 "../src/Views/FirmwareView.vala"
	gtk_widget_add_css_class ((GtkWidget*) suggested_button, GRANITE_STYLE_CLASS_DESTRUCTIVE_ACTION);
#line 389 "../src/Views/FirmwareView.vala"
	g_signal_connect_data ((GtkDialog*) _data9_->message_dialog, "response", (GCallback) ___lambda29__gtk_dialog_response, block9_data_ref (_data9_), (GClosureNotify) block9_data_unref, 0);
#line 396 "../src/Views/FirmwareView.vala"
	gtk_window_present ((GtkWindow*) _data9_->message_dialog);
#line 375 "../src/Views/FirmwareView.vala"
	_g_object_unref0 (suggested_button);
#line 375 "../src/Views/FirmwareView.vala"
	block9_data_unref (_data9_);
#line 375 "../src/Views/FirmwareView.vala"
	_data9_ = NULL;
#line 2754 "FirmwareView.c"
}

static Block10Data*
block10_data_ref (Block10Data* _data10_)
{
#line 399 "../src/Views/FirmwareView.vala"
	g_atomic_int_inc (&_data10_->_ref_count_);
#line 399 "../src/Views/FirmwareView.vala"
	return _data10_;
#line 2764 "FirmwareView.c"
}

static void
block10_data_unref (void * _userdata_)
{
	Block10Data* _data10_;
	_data10_ = (Block10Data*) _userdata_;
#line 399 "../src/Views/FirmwareView.vala"
	if (g_atomic_int_dec_and_test (&_data10_->_ref_count_)) {
#line 2774 "FirmwareView.c"
		AboutFirmwareView* self;
#line 399 "../src/Views/FirmwareView.vala"
		self = _data10_->self;
#line 399 "../src/Views/FirmwareView.vala"
		_g_object_unref0 (_data10_->dialog);
#line 399 "../src/Views/FirmwareView.vala"
		_g_object_unref0 (self);
#line 399 "../src/Views/FirmwareView.vala"
		g_slice_free (Block10Data, _data10_);
#line 2784 "FirmwareView.c"
	}
}

static void
__lambda30_ (Block10Data* _data10_,
             gint _result_)
{
	AboutFirmwareView* self;
	AboutLoginManager* login_manager = NULL;
	AboutLoginManager* _tmp0_;
	GError* _error_ = NULL;
	AboutLoginManager* _tmp1_;
	GError* _tmp2_;
	GError* _tmp3_;
	AboutLoginManager* _tmp17_;
#line 414 "../src/Views/FirmwareView.vala"
	self = _data10_->self;
#line 415 "../src/Views/FirmwareView.vala"
	gtk_window_destroy ((GtkWindow*) _data10_->dialog);
#line 417 "../src/Views/FirmwareView.vala"
	if (_result_ != ((gint) GTK_RESPONSE_ACCEPT)) {
#line 418 "../src/Views/FirmwareView.vala"
		return;
#line 2808 "FirmwareView.c"
	}
#line 421 "../src/Views/FirmwareView.vala"
	_tmp0_ = about_login_manager_get_instance ();
#line 421 "../src/Views/FirmwareView.vala"
	login_manager = _tmp0_;
#line 422 "../src/Views/FirmwareView.vala"
	_tmp1_ = login_manager;
#line 422 "../src/Views/FirmwareView.vala"
	_tmp2_ = about_login_manager_set_reboot_to_firmware_setup (_tmp1_);
#line 422 "../src/Views/FirmwareView.vala"
	_error_ = _tmp2_;
#line 424 "../src/Views/FirmwareView.vala"
	_tmp3_ = _error_;
#line 424 "../src/Views/FirmwareView.vala"
	if (_tmp3_ != NULL) {
#line 2824 "FirmwareView.c"
		GraniteMessageDialog* message_dialog = NULL;
		GThemedIcon* _tmp4_;
		GThemedIcon* _tmp5_;
		GThemedIcon* _tmp6_;
		GtkRoot* _tmp7_;
		GtkWindow* _tmp8_;
		GraniteMessageDialog* _tmp9_ = NULL;
		GraniteMessageDialog* _tmp10_;
		GraniteMessageDialog* _tmp11_;
		GError* _tmp12_;
		const gchar* _tmp13_;
		GraniteMessageDialog* _tmp14_;
		GraniteMessageDialog* _tmp15_;
		GraniteMessageDialog* _tmp16_;
#line 425 "../src/Views/FirmwareView.vala"
		_tmp4_ = (GThemedIcon*) g_themed_icon_new ("system-reboot");
#line 425 "../src/Views/FirmwareView.vala"
		_tmp5_ = _tmp4_;
#line 425 "../src/Views/FirmwareView.vala"
		_tmp6_ = (GThemedIcon*) g_themed_icon_new ("dialog-error");
#line 425 "../src/Views/FirmwareView.vala"
		_tmp7_ = gtk_widget_get_root ((GtkWidget*) self);
#line 425 "../src/Views/FirmwareView.vala"
		_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gtk_window_get_type (), GtkWindow));
#line 425 "../src/Views/FirmwareView.vala"
		_tmp9_ = granite_message_dialog_new (_ ("Unable to restart to firmware setup"), _ ("A system error prevented automatically restarting into firmware setup."), (GIcon*) _tmp5_, GTK_BUTTONS_CLOSE);
#line 425 "../src/Views/FirmwareView.vala"
		granite_message_dialog_set_badge_icon (_tmp9_, (GIcon*) _tmp6_);
#line 425 "../src/Views/FirmwareView.vala"
		_g_object_unref0 (_tmp6_);
#line 425 "../src/Views/FirmwareView.vala"
		gtk_window_set_modal ((GtkWindow*) _tmp9_, TRUE);
#line 425 "../src/Views/FirmwareView.vala"
		gtk_window_set_transient_for ((GtkWindow*) _tmp9_, _tmp8_);
#line 425 "../src/Views/FirmwareView.vala"
		_g_object_unref0 (_tmp8_);
#line 425 "../src/Views/FirmwareView.vala"
		g_object_ref_sink (_tmp9_);
#line 425 "../src/Views/FirmwareView.vala"
		_tmp10_ = _tmp9_;
#line 425 "../src/Views/FirmwareView.vala"
		_g_object_unref0 (_tmp5_);
#line 425 "../src/Views/FirmwareView.vala"
		message_dialog = _tmp10_;
#line 435 "../src/Views/FirmwareView.vala"
		_tmp11_ = message_dialog;
#line 435 "../src/Views/FirmwareView.vala"
		_tmp12_ = _error_;
#line 435 "../src/Views/FirmwareView.vala"
		_tmp13_ = _tmp12_->message;
#line 435 "../src/Views/FirmwareView.vala"
		granite_message_dialog_show_error_details (_tmp11_, _tmp13_);
#line 436 "../src/Views/FirmwareView.vala"
		_tmp14_ = message_dialog;
#line 436 "../src/Views/FirmwareView.vala"
		gtk_window_present ((GtkWindow*) _tmp14_);
#line 437 "../src/Views/FirmwareView.vala"
		_tmp15_ = message_dialog;
#line 437 "../src/Views/FirmwareView.vala"
		_tmp16_ = message_dialog;
#line 437 "../src/Views/FirmwareView.vala"
		g_signal_connect_object ((GtkDialog*) _tmp15_, "response", (GCallback) _gtk_window_destroy_gtk_dialog_response, (GtkWindow*) _tmp16_, 0);
#line 439 "../src/Views/FirmwareView.vala"
		_g_object_unref0 (message_dialog);
#line 439 "../src/Views/FirmwareView.vala"
		_g_error_free0 (_error_);
#line 439 "../src/Views/FirmwareView.vala"
		_g_object_unref0 (login_manager);
#line 439 "../src/Views/FirmwareView.vala"
		return;
#line 2895 "FirmwareView.c"
	}
#line 442 "../src/Views/FirmwareView.vala"
	_tmp17_ = login_manager;
#line 442 "../src/Views/FirmwareView.vala"
	about_login_manager_reboot (_tmp17_);
#line 414 "../src/Views/FirmwareView.vala"
	_g_error_free0 (_error_);
#line 414 "../src/Views/FirmwareView.vala"
	_g_object_unref0 (login_manager);
#line 2905 "FirmwareView.c"
}

static void
___lambda30__gtk_dialog_response (GtkDialog* _sender,
                                  gint response_id,
                                  gpointer self)
{
#line 414 "../src/Views/FirmwareView.vala"
	__lambda30_ (self, response_id);
#line 2915 "FirmwareView.c"
}

static void
about_firmware_view_reboot_to_firmware_setup_clicked (AboutFirmwareView* self)
{
	Block10Data* _data10_;
	GThemedIcon* _tmp0_;
	GThemedIcon* _tmp1_;
	GThemedIcon* _tmp2_;
	GtkRoot* _tmp3_;
	GtkWindow* _tmp4_;
	GraniteMessageDialog* _tmp5_ = NULL;
	GraniteMessageDialog* _tmp6_;
	GtkWidget* continue_button = NULL;
	GtkWidget* _tmp7_;
	GtkWidget* _tmp8_;
#line 399 "../src/Views/FirmwareView.vala"
	g_return_if_fail (self != NULL);
#line 399 "../src/Views/FirmwareView.vala"
	_data10_ = g_slice_new0 (Block10Data);
#line 399 "../src/Views/FirmwareView.vala"
	_data10_->_ref_count_ = 1;
#line 399 "../src/Views/FirmwareView.vala"
	_data10_->self = g_object_ref (self);
#line 400 "../src/Views/FirmwareView.vala"
	_tmp0_ = (GThemedIcon*) g_themed_icon_new ("system-reboot");
#line 400 "../src/Views/FirmwareView.vala"
	_tmp1_ = _tmp0_;
#line 400 "../src/Views/FirmwareView.vala"
	_tmp2_ = (GThemedIcon*) g_themed_icon_new ("application-x-firmware");
#line 400 "../src/Views/FirmwareView.vala"
	_tmp3_ = gtk_widget_get_root ((GtkWidget*) self);
#line 400 "../src/Views/FirmwareView.vala"
	_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_window_get_type (), GtkWindow));
#line 400 "../src/Views/FirmwareView.vala"
	_tmp5_ = granite_message_dialog_new (_ ("Restart to firmware setup"), _ ("This will close all open applications, restart this device, and open t" \
"he firmware setup screen."), (GIcon*) _tmp1_, GTK_BUTTONS_CANCEL);
#line 400 "../src/Views/FirmwareView.vala"
	granite_message_dialog_set_badge_icon (_tmp5_, (GIcon*) _tmp2_);
#line 400 "../src/Views/FirmwareView.vala"
	_g_object_unref0 (_tmp2_);
#line 400 "../src/Views/FirmwareView.vala"
	gtk_window_set_modal ((GtkWindow*) _tmp5_, TRUE);
#line 400 "../src/Views/FirmwareView.vala"
	gtk_window_set_transient_for ((GtkWindow*) _tmp5_, _tmp4_);
#line 400 "../src/Views/FirmwareView.vala"
	_g_object_unref0 (_tmp4_);
#line 400 "../src/Views/FirmwareView.vala"
	g_object_ref_sink (_tmp5_);
#line 400 "../src/Views/FirmwareView.vala"
	_tmp6_ = _tmp5_;
#line 400 "../src/Views/FirmwareView.vala"
	_g_object_unref0 (_tmp1_);
#line 400 "../src/Views/FirmwareView.vala"
	_data10_->dialog = _tmp6_;
#line 411 "../src/Views/FirmwareView.vala"
	_tmp7_ = granite_dialog_add_button ((GraniteDialog*) _data10_->dialog, _ ("Restart"), (gint) GTK_RESPONSE_ACCEPT);
#line 411 "../src/Views/FirmwareView.vala"
	_tmp8_ = _g_object_ref0 (_tmp7_);
#line 411 "../src/Views/FirmwareView.vala"
	continue_button = _tmp8_;
#line 412 "../src/Views/FirmwareView.vala"
	gtk_widget_add_css_class (continue_button, GRANITE_STYLE_CLASS_DESTRUCTIVE_ACTION);
#line 414 "../src/Views/FirmwareView.vala"
	g_signal_connect_data ((GtkDialog*) _data10_->dialog, "response", (GCallback) ___lambda30__gtk_dialog_response, block10_data_ref (_data10_), (GClosureNotify) block10_data_unref, 0);
#line 445 "../src/Views/FirmwareView.vala"
	gtk_window_present ((GtkWindow*) _data10_->dialog);
#line 399 "../src/Views/FirmwareView.vala"
	_g_object_unref0 (continue_button);
#line 399 "../src/Views/FirmwareView.vala"
	block10_data_unref (_data10_);
#line 399 "../src/Views/FirmwareView.vala"
	_data10_ = NULL;
#line 2988 "FirmwareView.c"
}

static void
_about_firmware_view_reboot_to_firmware_setup_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                          gpointer self)
{
#line 87 "../src/Views/FirmwareView.vala"
	about_firmware_view_reboot_to_firmware_setup_clicked ((AboutFirmwareView*) self);
#line 2997 "FirmwareView.c"
}

static void
_about_firmware_view_on_device_added_fwupd_client_device_added (FwupdClient* _sender,
                                                                FwupdDevice* _result_,
                                                                gpointer self)
{
#line 91 "../src/Views/FirmwareView.vala"
	about_firmware_view_on_device_added ((AboutFirmwareView*) self, _sender, _result_);
#line 3007 "FirmwareView.c"
}

static void
_about_firmware_view_on_device_removed_fwupd_client_device_removed (FwupdClient* _sender,
                                                                    FwupdDevice* _result_,
                                                                    gpointer self)
{
#line 92 "../src/Views/FirmwareView.vala"
	about_firmware_view_on_device_removed ((AboutFirmwareView*) self, _sender, _result_);
#line 3017 "FirmwareView.c"
}

static void
_about_firmware_view_show_release_gtk_list_box_row_activated (GtkListBox* _sender,
                                                              GtkListBoxRow* row,
                                                              gpointer self)
{
#line 96 "../src/Views/FirmwareView.vala"
	about_firmware_view_show_release ((AboutFirmwareView*) self, row);
#line 3027 "FirmwareView.c"
}

static void
_about_firmware_view___lambda31_ (AboutFirmwareView* self,
                                  FwupdDevice* device,
                                  FwupdRelease* release)
{
#line 98 "../src/Views/FirmwareView.vala"
	g_return_if_fail (device != NULL);
#line 98 "../src/Views/FirmwareView.vala"
	g_return_if_fail (release != NULL);
#line 99 "../src/Views/FirmwareView.vala"
	about_firmware_view_update (self, device, release, NULL, NULL);
#line 3041 "FirmwareView.c"
}

static void
__about_firmware_view___lambda31__about_firmware_release_view_update (AboutFirmwareReleaseView* _sender,
                                                                      FwupdDevice* device,
                                                                      FwupdRelease* release,
                                                                      gpointer self)
{
#line 98 "../src/Views/FirmwareView.vala"
	_about_firmware_view___lambda31_ ((AboutFirmwareView*) self, device, release);
#line 3052 "FirmwareView.c"
}

static GObject *
about_firmware_view_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	AboutFirmwareView * self;
	gchar* _tmp0_;
	GThemedIcon* _tmp1_;
	GranitePlaceholder* _tmp2_ = NULL;
	gchar* _tmp3_;
	GThemedIcon* _tmp4_;
	GranitePlaceholder* _tmp5_ = NULL;
	GtkListBox* _tmp6_ = NULL;
	GtkListBox* _tmp7_;
	GtkListBox* _tmp8_;
	GtkListBox* _tmp9_;
	GranitePlaceholder* _tmp10_;
	GtkScrolledWindow* update_scrolled = NULL;
	GtkListBox* _tmp11_;
	GtkWidget* _tmp12_;
	GtkScrolledWindow* _tmp13_ = NULL;
	AboutFirmwareReleaseView* _tmp14_;
	AdwLeaflet* _tmp15_ = NULL;
	AdwLeaflet* _tmp16_;
	GtkScrolledWindow* _tmp17_;
	AdwLeaflet* _tmp18_;
	AboutFirmwareReleaseView* _tmp19_;
	AdwLeaflet* _tmp20_;
	GtkScrolledWindow* _tmp21_;
	GtkStack* _tmp22_ = NULL;
	GtkStack* _tmp23_;
	AdwLeaflet* _tmp24_;
	GtkStack* _tmp25_;
	GranitePlaceholder* _tmp26_;
	GtkFrame* frame = NULL;
	GtkStack* _tmp27_;
	GtkWidget* _tmp28_;
	GtkFrame* _tmp29_ = NULL;
	GtkFrame* _tmp30_;
	AboutLoginManager* _tmp31_;
	AboutLoginManager* _tmp32_;
	gboolean _tmp33_;
	FwupdClient* _tmp36_;
	FwupdClient* _tmp37_;
	FwupdClient* _tmp38_;
	GtkListBox* _tmp39_;
	AboutFirmwareReleaseView* _tmp40_;
#line 40 "../src/Views/FirmwareView.vala"
	parent_class = G_OBJECT_CLASS (about_firmware_view_parent_class);
#line 40 "../src/Views/FirmwareView.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 40 "../src/Views/FirmwareView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, ABOUT_TYPE_FIRMWARE_VIEW, AboutFirmwareView);
#line 41 "../src/Views/FirmwareView.vala"
	_tmp0_ = g_strdup (_ ("Do not unplug the device during the update."));
#line 41 "../src/Views/FirmwareView.vala"
	_tmp1_ = (GThemedIcon*) g_themed_icon_new ("emblem-synchronized");
#line 41 "../src/Views/FirmwareView.vala"
	_tmp2_ = granite_placeholder_new ("");
#line 41 "../src/Views/FirmwareView.vala"
	granite_placeholder_set_description (_tmp2_, _tmp0_);
#line 41 "../src/Views/FirmwareView.vala"
	_g_free0 (_tmp0_);
#line 41 "../src/Views/FirmwareView.vala"
	granite_placeholder_set_icon (_tmp2_, (GIcon*) _tmp1_);
#line 41 "../src/Views/FirmwareView.vala"
	_g_object_unref0 (_tmp1_);
#line 41 "../src/Views/FirmwareView.vala"
	g_object_ref_sink (_tmp2_);
#line 41 "../src/Views/FirmwareView.vala"
	_g_object_unref0 (self->priv->progress_alert_view);
#line 41 "../src/Views/FirmwareView.vala"
	self->priv->progress_alert_view = _tmp2_;
#line 46 "../src/Views/FirmwareView.vala"
	_tmp3_ = g_strdup (_ ("Connecting to the firmware service and searching for updates."));
#line 46 "../src/Views/FirmwareView.vala"
	_tmp4_ = (GThemedIcon*) g_themed_icon_new ("sync-synchronizing");
#line 46 "../src/Views/FirmwareView.vala"
	_tmp5_ = granite_placeholder_new (_ ("Checking for Updates"));
#line 46 "../src/Views/FirmwareView.vala"
	granite_placeholder_set_description (_tmp5_, _tmp3_);
#line 46 "../src/Views/FirmwareView.vala"
	_g_free0 (_tmp3_);
#line 46 "../src/Views/FirmwareView.vala"
	granite_placeholder_set_icon (_tmp5_, (GIcon*) _tmp4_);
#line 46 "../src/Views/FirmwareView.vala"
	_g_object_unref0 (_tmp4_);
#line 46 "../src/Views/FirmwareView.vala"
	g_object_ref_sink (_tmp5_);
#line 46 "../src/Views/FirmwareView.vala"
	_g_object_unref0 (self->priv->placeholder_alert_view);
#line 46 "../src/Views/FirmwareView.vala"
	self->priv->placeholder_alert_view = _tmp5_;
#line 51 "../src/Views/FirmwareView.vala"
	_tmp6_ = (GtkListBox*) gtk_list_box_new ();
#line 51 "../src/Views/FirmwareView.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _tmp6_, TRUE);
#line 51 "../src/Views/FirmwareView.vala"
	gtk_list_box_set_selection_mode (_tmp6_, GTK_SELECTION_SINGLE);
#line 51 "../src/Views/FirmwareView.vala"
	g_object_ref_sink (_tmp6_);
#line 51 "../src/Views/FirmwareView.vala"
	_g_object_unref0 (self->priv->update_list);
#line 51 "../src/Views/FirmwareView.vala"
	self->priv->update_list = _tmp6_;
#line 55 "../src/Views/FirmwareView.vala"
	_tmp7_ = self->priv->update_list;
#line 55 "../src/Views/FirmwareView.vala"
	gtk_list_box_set_sort_func (_tmp7_, (GtkListBoxSortFunc) about_firmware_view_compare_rows, g_object_ref (self), g_object_unref);
#line 56 "../src/Views/FirmwareView.vala"
	_tmp8_ = self->priv->update_list;
#line 56 "../src/Views/FirmwareView.vala"
	gtk_list_box_set_header_func (_tmp8_, (GtkListBoxUpdateHeaderFunc) about_firmware_view_header_rows, g_object_ref (self), g_object_unref);
#line 57 "../src/Views/FirmwareView.vala"
	_tmp9_ = self->priv->update_list;
#line 57 "../src/Views/FirmwareView.vala"
	_tmp10_ = self->priv->placeholder_alert_view;
#line 57 "../src/Views/FirmwareView.vala"
	gtk_list_box_set_placeholder (_tmp9_, (GtkWidget*) _tmp10_);
#line 59 "../src/Views/FirmwareView.vala"
	_tmp11_ = self->priv->update_list;
#line 59 "../src/Views/FirmwareView.vala"
	_tmp12_ = _g_object_ref0 ((GtkWidget*) _tmp11_);
#line 59 "../src/Views/FirmwareView.vala"
	_tmp13_ = (GtkScrolledWindow*) gtk_scrolled_window_new ();
#line 59 "../src/Views/FirmwareView.vala"
	gtk_scrolled_window_set_child (_tmp13_, _tmp12_);
#line 59 "../src/Views/FirmwareView.vala"
	_g_object_unref0 (_tmp12_);
#line 59 "../src/Views/FirmwareView.vala"
	g_object_ref_sink (_tmp13_);
#line 59 "../src/Views/FirmwareView.vala"
	update_scrolled = _tmp13_;
#line 63 "../src/Views/FirmwareView.vala"
	_tmp14_ = about_firmware_release_view_new ();
#line 63 "../src/Views/FirmwareView.vala"
	g_object_ref_sink (_tmp14_);
#line 63 "../src/Views/FirmwareView.vala"
	_g_object_unref0 (self->priv->firmware_release_view);
#line 63 "../src/Views/FirmwareView.vala"
	self->priv->firmware_release_view = _tmp14_;
#line 65 "../src/Views/FirmwareView.vala"
	_tmp15_ = (AdwLeaflet*) adw_leaflet_new ();
#line 65 "../src/Views/FirmwareView.vala"
	adw_leaflet_set_can_navigate_back (_tmp15_, TRUE);
#line 65 "../src/Views/FirmwareView.vala"
	adw_leaflet_set_can_unfold (_tmp15_, FALSE);
#line 65 "../src/Views/FirmwareView.vala"
	g_object_ref_sink (_tmp15_);
#line 65 "../src/Views/FirmwareView.vala"
	_g_object_unref0 (self->priv->deck);
#line 65 "../src/Views/FirmwareView.vala"
	self->priv->deck = _tmp15_;
#line 69 "../src/Views/FirmwareView.vala"
	_tmp16_ = self->priv->deck;
#line 69 "../src/Views/FirmwareView.vala"
	_tmp17_ = update_scrolled;
#line 69 "../src/Views/FirmwareView.vala"
	adw_leaflet_append (_tmp16_, (GtkWidget*) _tmp17_);
#line 70 "../src/Views/FirmwareView.vala"
	_tmp18_ = self->priv->deck;
#line 70 "../src/Views/FirmwareView.vala"
	_tmp19_ = self->priv->firmware_release_view;
#line 70 "../src/Views/FirmwareView.vala"
	adw_leaflet_append (_tmp18_, (GtkWidget*) _tmp19_);
#line 71 "../src/Views/FirmwareView.vala"
	_tmp20_ = self->priv->deck;
#line 71 "../src/Views/FirmwareView.vala"
	_tmp21_ = update_scrolled;
#line 71 "../src/Views/FirmwareView.vala"
	adw_leaflet_set_visible_child (_tmp20_, (GtkWidget*) _tmp21_);
#line 73 "../src/Views/FirmwareView.vala"
	_tmp22_ = (GtkStack*) gtk_stack_new ();
#line 73 "../src/Views/FirmwareView.vala"
	gtk_stack_set_transition_type (_tmp22_, GTK_STACK_TRANSITION_TYPE_SLIDE_LEFT_RIGHT);
#line 73 "../src/Views/FirmwareView.vala"
	g_object_ref_sink (_tmp22_);
#line 73 "../src/Views/FirmwareView.vala"
	_g_object_unref0 (self->priv->stack);
#line 73 "../src/Views/FirmwareView.vala"
	self->priv->stack = _tmp22_;
#line 76 "../src/Views/FirmwareView.vala"
	_tmp23_ = self->priv->stack;
#line 76 "../src/Views/FirmwareView.vala"
	_tmp24_ = self->priv->deck;
#line 76 "../src/Views/FirmwareView.vala"
	gtk_stack_add_child (_tmp23_, (GtkWidget*) _tmp24_);
#line 77 "../src/Views/FirmwareView.vala"
	_tmp25_ = self->priv->stack;
#line 77 "../src/Views/FirmwareView.vala"
	_tmp26_ = self->priv->progress_alert_view;
#line 77 "../src/Views/FirmwareView.vala"
	gtk_stack_add_child (_tmp25_, (GtkWidget*) _tmp26_);
#line 79 "../src/Views/FirmwareView.vala"
	_tmp27_ = self->priv->stack;
#line 79 "../src/Views/FirmwareView.vala"
	_tmp28_ = _g_object_ref0 ((GtkWidget*) _tmp27_);
#line 79 "../src/Views/FirmwareView.vala"
	_tmp29_ = (GtkFrame*) gtk_frame_new (NULL);
#line 79 "../src/Views/FirmwareView.vala"
	gtk_frame_set_child (_tmp29_, _tmp28_);
#line 79 "../src/Views/FirmwareView.vala"
	_g_object_unref0 (_tmp28_);
#line 79 "../src/Views/FirmwareView.vala"
	g_object_ref_sink (_tmp29_);
#line 79 "../src/Views/FirmwareView.vala"
	frame = _tmp29_;
#line 83 "../src/Views/FirmwareView.vala"
	_tmp30_ = frame;
#line 83 "../src/Views/FirmwareView.vala"
	switchboard_settings_page_set_child ((SwitchboardSettingsPage*) self, (GtkWidget*) _tmp30_);
#line 85 "../src/Views/FirmwareView.vala"
	_tmp31_ = about_login_manager_get_instance ();
#line 85 "../src/Views/FirmwareView.vala"
	_tmp32_ = _tmp31_;
#line 85 "../src/Views/FirmwareView.vala"
	_tmp33_ = about_login_manager_can_reboot_to_firmware_setup (_tmp32_);
#line 85 "../src/Views/FirmwareView.vala"
	_g_object_unref0 (_tmp32_);
#line 85 "../src/Views/FirmwareView.vala"
	if (_tmp33_) {
#line 3278 "FirmwareView.c"
		GtkButton* reboot_to_firmware_setup_button = NULL;
		GtkButton* _tmp34_;
		GtkButton* _tmp35_;
#line 86 "../src/Views/FirmwareView.vala"
		_tmp34_ = switchboard_settings_page_add_button ((SwitchboardSettingsPage*) self, _ ("Restart to Firmware Setup…"));
#line 86 "../src/Views/FirmwareView.vala"
		reboot_to_firmware_setup_button = _tmp34_;
#line 87 "../src/Views/FirmwareView.vala"
		_tmp35_ = reboot_to_firmware_setup_button;
#line 87 "../src/Views/FirmwareView.vala"
		g_signal_connect_object (_tmp35_, "clicked", (GCallback) _about_firmware_view_reboot_to_firmware_setup_clicked_gtk_button_clicked, self, 0);
#line 85 "../src/Views/FirmwareView.vala"
		_g_object_unref0 (reboot_to_firmware_setup_button);
#line 3292 "FirmwareView.c"
	}
#line 90 "../src/Views/FirmwareView.vala"
	_tmp36_ = fwupd_client_new ();
#line 90 "../src/Views/FirmwareView.vala"
	_g_object_unref0 (self->priv->fwupd_client);
#line 90 "../src/Views/FirmwareView.vala"
	self->priv->fwupd_client = _tmp36_;
#line 91 "../src/Views/FirmwareView.vala"
	_tmp37_ = self->priv->fwupd_client;
#line 91 "../src/Views/FirmwareView.vala"
	g_signal_connect_object (_tmp37_, "device-added", (GCallback) _about_firmware_view_on_device_added_fwupd_client_device_added, self, 0);
#line 92 "../src/Views/FirmwareView.vala"
	_tmp38_ = self->priv->fwupd_client;
#line 92 "../src/Views/FirmwareView.vala"
	g_signal_connect_object (_tmp38_, "device-removed", (GCallback) _about_firmware_view_on_device_removed_fwupd_client_device_removed, self, 0);
#line 94 "../src/Views/FirmwareView.vala"
	about_firmware_view_update_list_view (self, NULL, NULL);
#line 96 "../src/Views/FirmwareView.vala"
	_tmp39_ = self->priv->update_list;
#line 96 "../src/Views/FirmwareView.vala"
	g_signal_connect_object (_tmp39_, "row-activated", (GCallback) _about_firmware_view_show_release_gtk_list_box_row_activated, self, 0);
#line 98 "../src/Views/FirmwareView.vala"
	_tmp40_ = self->priv->firmware_release_view;
#line 98 "../src/Views/FirmwareView.vala"
	g_signal_connect_object (_tmp40_, "update", (GCallback) __about_firmware_view___lambda31__about_firmware_release_view_update, self, 0);
#line 40 "../src/Views/FirmwareView.vala"
	_g_object_unref0 (frame);
#line 40 "../src/Views/FirmwareView.vala"
	_g_object_unref0 (update_scrolled);
#line 40 "../src/Views/FirmwareView.vala"
	return obj;
#line 3324 "FirmwareView.c"
}

static void
about_firmware_view_class_init (AboutFirmwareViewClass * klass,
                                gpointer klass_data)
{
#line 22 "../src/Views/FirmwareView.vala"
	about_firmware_view_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/Views/FirmwareView.vala"
	g_type_class_adjust_private_offset (klass, &AboutFirmwareView_private_offset);
#line 22 "../src/Views/FirmwareView.vala"
	G_OBJECT_CLASS (klass)->constructor = about_firmware_view_constructor;
#line 22 "../src/Views/FirmwareView.vala"
	G_OBJECT_CLASS (klass)->finalize = about_firmware_view_finalize;
#line 3339 "FirmwareView.c"
}

static void
about_firmware_view_instance_init (AboutFirmwareView * self,
                                   gpointer klass)
{
#line 22 "../src/Views/FirmwareView.vala"
	self->priv = about_firmware_view_get_instance_private (self);
#line 29 "../src/Views/FirmwareView.vala"
	self->priv->num_updates = (guint) 0;
#line 3350 "FirmwareView.c"
}

static void
about_firmware_view_finalize (GObject * obj)
{
	AboutFirmwareView * self;
#line 22 "../src/Views/FirmwareView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, ABOUT_TYPE_FIRMWARE_VIEW, AboutFirmwareView);
#line 23 "../src/Views/FirmwareView.vala"
	_g_object_unref0 (self->priv->stack);
#line 24 "../src/Views/FirmwareView.vala"
	_g_object_unref0 (self->priv->deck);
#line 25 "../src/Views/FirmwareView.vala"
	_g_object_unref0 (self->priv->firmware_release_view);
#line 26 "../src/Views/FirmwareView.vala"
	_g_object_unref0 (self->priv->progress_alert_view);
#line 27 "../src/Views/FirmwareView.vala"
	_g_object_unref0 (self->priv->placeholder_alert_view);
#line 28 "../src/Views/FirmwareView.vala"
	_g_object_unref0 (self->priv->update_list);
#line 30 "../src/Views/FirmwareView.vala"
	_g_object_unref0 (self->priv->fwupd_client);
#line 22 "../src/Views/FirmwareView.vala"
	G_OBJECT_CLASS (about_firmware_view_parent_class)->finalize (obj);
#line 3375 "FirmwareView.c"
}

 G_GNUC_NO_INLINE static GType
about_firmware_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (AboutFirmwareViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) about_firmware_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AboutFirmwareView), 0, (GInstanceInitFunc) about_firmware_view_instance_init, NULL };
	GType about_firmware_view_type_id;
	about_firmware_view_type_id = g_type_register_static (SWITCHBOARD_TYPE_SETTINGS_PAGE, "AboutFirmwareView", &g_define_type_info, 0);
	AboutFirmwareView_private_offset = g_type_add_instance_private (about_firmware_view_type_id, sizeof (AboutFirmwareViewPrivate));
	return about_firmware_view_type_id;
}

GType
about_firmware_view_get_type (void)
{
	static volatile gsize about_firmware_view_type_id__once = 0;
	if (g_once_init_enter (&about_firmware_view_type_id__once)) {
		GType about_firmware_view_type_id;
		about_firmware_view_type_id = about_firmware_view_get_type_once ();
		g_once_init_leave (&about_firmware_view_type_id__once, about_firmware_view_type_id);
	}
	return about_firmware_view_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

