/* DriverRow.c generated by valac 0.56.17, the Vala compiler
 * generated from DriverRow.vala, do not modify */

/*
 * Copyright 2024 elementary, Inc. (https://elementary.io)
 * SPDX-License-Identifier: GPL-3.0-or-later
 *
 * Authored by: Leonhard Kargl <leo.kargl@proton.me>
 */

#include "system.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	ABOUT_DRIVER_ROW_0_PROPERTY,
	ABOUT_DRIVER_ROW_DEVICE_PROPERTY,
	ABOUT_DRIVER_ROW_DRIVER_NAME_PROPERTY,
	ABOUT_DRIVER_ROW_INSTALLED_PROPERTY,
	ABOUT_DRIVER_ROW_INSTALL_BUTTON_PROPERTY,
	ABOUT_DRIVER_ROW_NUM_PROPERTIES
};
static GParamSpec* about_driver_row_properties[ABOUT_DRIVER_ROW_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	ABOUT_DRIVER_ROW_INSTALL_SIGNAL,
	ABOUT_DRIVER_ROW_NUM_SIGNALS
};
static guint about_driver_row_signals[ABOUT_DRIVER_ROW_NUM_SIGNALS] = {0};

struct _AboutDriverRowPrivate {
	gchar* _device;
	gchar* _driver_name;
	gboolean _installed;
	GtkCheckButton* _install_button;
};

static gint AboutDriverRow_private_offset;
static gpointer about_driver_row_parent_class = NULL;

static GObject * about_driver_row_constructor (GType type,
                                        guint n_construct_properties,
                                        GObjectConstructParam * construct_properties);
static void _about_driver_row___lambda32_ (AboutDriverRow* self);
static void __about_driver_row___lambda32__gtk_check_button_toggled (GtkCheckButton* _sender,
                                                              gpointer self);
static void about_driver_row_finalize (GObject * obj);
static GType about_driver_row_get_type_once (void);
static void _vala_about_driver_row_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec);
static void _vala_about_driver_row_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
about_driver_row_get_instance_private (AboutDriverRow* self)
{
	return G_STRUCT_MEMBER_P (self, AboutDriverRow_private_offset);
}

AboutDriverRow*
about_driver_row_construct (GType object_type,
                            const gchar* device,
                            const gchar* driver_name,
                            gboolean installed)
{
	AboutDriverRow * self = NULL;
#line 17 "../src/Widgets/DriverRow.vala"
	g_return_val_if_fail (device != NULL, NULL);
#line 17 "../src/Widgets/DriverRow.vala"
	g_return_val_if_fail (driver_name != NULL, NULL);
#line 18 "../src/Widgets/DriverRow.vala"
	self = (AboutDriverRow*) g_object_new (object_type, "device", device, "driver-name", driver_name, "installed", installed, NULL);
#line 17 "../src/Widgets/DriverRow.vala"
	return self;
#line 97 "DriverRow.c"
}

AboutDriverRow*
about_driver_row_new (const gchar* device,
                      const gchar* driver_name,
                      gboolean installed)
{
#line 17 "../src/Widgets/DriverRow.vala"
	return about_driver_row_construct (ABOUT_TYPE_DRIVER_ROW, device, driver_name, installed);
#line 107 "DriverRow.c"
}

const gchar*
about_driver_row_get_device (AboutDriverRow* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 11 "../src/Widgets/DriverRow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 11 "../src/Widgets/DriverRow.vala"
	_tmp0_ = self->priv->_device;
#line 11 "../src/Widgets/DriverRow.vala"
	result = _tmp0_;
#line 11 "../src/Widgets/DriverRow.vala"
	return result;
#line 123 "DriverRow.c"
}

static void
about_driver_row_set_device (AboutDriverRow* self,
                             const gchar* value)
{
	gchar* old_value;
#line 11 "../src/Widgets/DriverRow.vala"
	g_return_if_fail (self != NULL);
#line 11 "../src/Widgets/DriverRow.vala"
	old_value = about_driver_row_get_device (self);
#line 11 "../src/Widgets/DriverRow.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 137 "DriverRow.c"
		gchar* _tmp0_;
#line 11 "../src/Widgets/DriverRow.vala"
		_tmp0_ = g_strdup (value);
#line 11 "../src/Widgets/DriverRow.vala"
		_g_free0 (self->priv->_device);
#line 11 "../src/Widgets/DriverRow.vala"
		self->priv->_device = _tmp0_;
#line 11 "../src/Widgets/DriverRow.vala"
		g_object_notify_by_pspec ((GObject *) self, about_driver_row_properties[ABOUT_DRIVER_ROW_DEVICE_PROPERTY]);
#line 147 "DriverRow.c"
	}
}

const gchar*
about_driver_row_get_driver_name (AboutDriverRow* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 12 "../src/Widgets/DriverRow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 12 "../src/Widgets/DriverRow.vala"
	_tmp0_ = self->priv->_driver_name;
#line 12 "../src/Widgets/DriverRow.vala"
	result = _tmp0_;
#line 12 "../src/Widgets/DriverRow.vala"
	return result;
#line 164 "DriverRow.c"
}

static void
about_driver_row_set_driver_name (AboutDriverRow* self,
                                  const gchar* value)
{
	gchar* old_value;
#line 12 "../src/Widgets/DriverRow.vala"
	g_return_if_fail (self != NULL);
#line 12 "../src/Widgets/DriverRow.vala"
	old_value = about_driver_row_get_driver_name (self);
#line 12 "../src/Widgets/DriverRow.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 178 "DriverRow.c"
		gchar* _tmp0_;
#line 12 "../src/Widgets/DriverRow.vala"
		_tmp0_ = g_strdup (value);
#line 12 "../src/Widgets/DriverRow.vala"
		_g_free0 (self->priv->_driver_name);
#line 12 "../src/Widgets/DriverRow.vala"
		self->priv->_driver_name = _tmp0_;
#line 12 "../src/Widgets/DriverRow.vala"
		g_object_notify_by_pspec ((GObject *) self, about_driver_row_properties[ABOUT_DRIVER_ROW_DRIVER_NAME_PROPERTY]);
#line 188 "DriverRow.c"
	}
}

gboolean
about_driver_row_get_installed (AboutDriverRow* self)
{
	gboolean result;
#line 13 "../src/Widgets/DriverRow.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 13 "../src/Widgets/DriverRow.vala"
	result = self->priv->_installed;
#line 13 "../src/Widgets/DriverRow.vala"
	return result;
#line 202 "DriverRow.c"
}

static void
about_driver_row_set_installed (AboutDriverRow* self,
                                gboolean value)
{
	gboolean old_value;
#line 13 "../src/Widgets/DriverRow.vala"
	g_return_if_fail (self != NULL);
#line 13 "../src/Widgets/DriverRow.vala"
	old_value = about_driver_row_get_installed (self);
#line 13 "../src/Widgets/DriverRow.vala"
	if (old_value != value) {
#line 13 "../src/Widgets/DriverRow.vala"
		self->priv->_installed = value;
#line 13 "../src/Widgets/DriverRow.vala"
		g_object_notify_by_pspec ((GObject *) self, about_driver_row_properties[ABOUT_DRIVER_ROW_INSTALLED_PROPERTY]);
#line 220 "DriverRow.c"
	}
}

GtkCheckButton*
about_driver_row_get_install_button (AboutDriverRow* self)
{
	GtkCheckButton* result;
	GtkCheckButton* _tmp0_;
#line 15 "../src/Widgets/DriverRow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 15 "../src/Widgets/DriverRow.vala"
	_tmp0_ = self->priv->_install_button;
#line 15 "../src/Widgets/DriverRow.vala"
	result = _tmp0_;
#line 15 "../src/Widgets/DriverRow.vala"
	return result;
#line 237 "DriverRow.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 15 "../src/Widgets/DriverRow.vala"
	return self ? g_object_ref (self) : NULL;
#line 245 "DriverRow.c"
}

static void
about_driver_row_set_install_button (AboutDriverRow* self,
                                     GtkCheckButton* value)
{
	GtkCheckButton* old_value;
#line 15 "../src/Widgets/DriverRow.vala"
	g_return_if_fail (self != NULL);
#line 15 "../src/Widgets/DriverRow.vala"
	old_value = about_driver_row_get_install_button (self);
#line 15 "../src/Widgets/DriverRow.vala"
	if (old_value != value) {
#line 259 "DriverRow.c"
		GtkCheckButton* _tmp0_;
#line 15 "../src/Widgets/DriverRow.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 15 "../src/Widgets/DriverRow.vala"
		_g_object_unref0 (self->priv->_install_button);
#line 15 "../src/Widgets/DriverRow.vala"
		self->priv->_install_button = _tmp0_;
#line 15 "../src/Widgets/DriverRow.vala"
		g_object_notify_by_pspec ((GObject *) self, about_driver_row_properties[ABOUT_DRIVER_ROW_INSTALL_BUTTON_PROPERTY]);
#line 269 "DriverRow.c"
	}
}

static void
_about_driver_row___lambda32_ (AboutDriverRow* self)
{
	GtkCheckButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 44 "../src/Widgets/DriverRow.vala"
	_tmp0_ = self->priv->_install_button;
#line 44 "../src/Widgets/DriverRow.vala"
	_tmp1_ = gtk_check_button_get_active (_tmp0_);
#line 44 "../src/Widgets/DriverRow.vala"
	_tmp2_ = _tmp1_;
#line 44 "../src/Widgets/DriverRow.vala"
	if (_tmp2_) {
#line 45 "../src/Widgets/DriverRow.vala"
		g_signal_emit (self, about_driver_row_signals[ABOUT_DRIVER_ROW_INSTALL_SIGNAL], 0);
#line 289 "DriverRow.c"
	}
}

static void
__about_driver_row___lambda32__gtk_check_button_toggled (GtkCheckButton* _sender,
                                                         gpointer self)
{
#line 43 "../src/Widgets/DriverRow.vala"
	_about_driver_row___lambda32_ ((AboutDriverRow*) self);
#line 299 "DriverRow.c"
}

static GObject *
about_driver_row_constructor (GType type,
                              guint n_construct_properties,
                              GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	AboutDriverRow * self;
	GtkImage* icon = NULL;
	GtkImage* _tmp0_ = NULL;
	GtkLabel* label = NULL;
	const gchar* _tmp1_;
	GtkLabel* _tmp2_ = NULL;
	gboolean _tmp3_;
	GtkCheckButton* _tmp4_ = NULL;
	GtkCheckButton* _tmp5_;
	GtkBox* box = NULL;
	GtkBox* _tmp6_;
	GtkBox* _tmp7_;
	GtkImage* _tmp8_;
	GtkBox* _tmp9_;
	GtkLabel* _tmp10_;
	GtkBox* _tmp11_;
	GtkCheckButton* _tmp12_;
	GtkBox* _tmp13_;
	GtkCheckButton* _tmp14_;
#line 21 "../src/Widgets/DriverRow.vala"
	parent_class = G_OBJECT_CLASS (about_driver_row_parent_class);
#line 21 "../src/Widgets/DriverRow.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 21 "../src/Widgets/DriverRow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, ABOUT_TYPE_DRIVER_ROW, AboutDriverRow);
#line 22 "../src/Widgets/DriverRow.vala"
	_tmp0_ = (GtkImage*) gtk_image_new_from_icon_name ("application-x-firmware");
#line 22 "../src/Widgets/DriverRow.vala"
	gtk_image_set_pixel_size (_tmp0_, 32);
#line 22 "../src/Widgets/DriverRow.vala"
	g_object_ref_sink (_tmp0_);
#line 22 "../src/Widgets/DriverRow.vala"
	icon = _tmp0_;
#line 26 "../src/Widgets/DriverRow.vala"
	_tmp1_ = self->priv->_driver_name;
#line 26 "../src/Widgets/DriverRow.vala"
	_tmp2_ = (GtkLabel*) gtk_label_new (_tmp1_);
#line 26 "../src/Widgets/DriverRow.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp2_, TRUE);
#line 26 "../src/Widgets/DriverRow.vala"
	gtk_label_set_xalign (_tmp2_, (gfloat) 0);
#line 26 "../src/Widgets/DriverRow.vala"
	g_object_ref_sink (_tmp2_);
#line 26 "../src/Widgets/DriverRow.vala"
	label = _tmp2_;
#line 31 "../src/Widgets/DriverRow.vala"
	_tmp3_ = self->priv->_installed;
#line 31 "../src/Widgets/DriverRow.vala"
	_tmp4_ = (GtkCheckButton*) gtk_check_button_new ();
#line 31 "../src/Widgets/DriverRow.vala"
	gtk_check_button_set_active (_tmp4_, _tmp3_);
#line 31 "../src/Widgets/DriverRow.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp4_, GTK_ALIGN_CENTER);
#line 31 "../src/Widgets/DriverRow.vala"
	g_object_ref_sink (_tmp4_);
#line 31 "../src/Widgets/DriverRow.vala"
	_tmp5_ = _tmp4_;
#line 31 "../src/Widgets/DriverRow.vala"
	about_driver_row_set_install_button (self, _tmp5_);
#line 31 "../src/Widgets/DriverRow.vala"
	_g_object_unref0 (_tmp5_);
#line 36 "../src/Widgets/DriverRow.vala"
	_tmp6_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 6);
#line 36 "../src/Widgets/DriverRow.vala"
	g_object_ref_sink (_tmp6_);
#line 36 "../src/Widgets/DriverRow.vala"
	box = _tmp6_;
#line 37 "../src/Widgets/DriverRow.vala"
	_tmp7_ = box;
#line 37 "../src/Widgets/DriverRow.vala"
	_tmp8_ = icon;
#line 37 "../src/Widgets/DriverRow.vala"
	gtk_box_append (_tmp7_, (GtkWidget*) _tmp8_);
#line 38 "../src/Widgets/DriverRow.vala"
	_tmp9_ = box;
#line 38 "../src/Widgets/DriverRow.vala"
	_tmp10_ = label;
#line 38 "../src/Widgets/DriverRow.vala"
	gtk_box_append (_tmp9_, (GtkWidget*) _tmp10_);
#line 39 "../src/Widgets/DriverRow.vala"
	_tmp11_ = box;
#line 39 "../src/Widgets/DriverRow.vala"
	_tmp12_ = self->priv->_install_button;
#line 39 "../src/Widgets/DriverRow.vala"
	gtk_box_append (_tmp11_, (GtkWidget*) _tmp12_);
#line 41 "../src/Widgets/DriverRow.vala"
	_tmp13_ = box;
#line 41 "../src/Widgets/DriverRow.vala"
	gtk_list_box_row_set_child ((GtkListBoxRow*) self, (GtkWidget*) _tmp13_);
#line 43 "../src/Widgets/DriverRow.vala"
	_tmp14_ = self->priv->_install_button;
#line 43 "../src/Widgets/DriverRow.vala"
	g_signal_connect_object (_tmp14_, "toggled", (GCallback) __about_driver_row___lambda32__gtk_check_button_toggled, self, 0);
#line 21 "../src/Widgets/DriverRow.vala"
	_g_object_unref0 (box);
#line 21 "../src/Widgets/DriverRow.vala"
	_g_object_unref0 (label);
#line 21 "../src/Widgets/DriverRow.vala"
	_g_object_unref0 (icon);
#line 21 "../src/Widgets/DriverRow.vala"
	return obj;
#line 410 "DriverRow.c"
}

static void
about_driver_row_class_init (AboutDriverRowClass * klass,
                             gpointer klass_data)
{
#line 8 "../src/Widgets/DriverRow.vala"
	about_driver_row_parent_class = g_type_class_peek_parent (klass);
#line 8 "../src/Widgets/DriverRow.vala"
	g_type_class_adjust_private_offset (klass, &AboutDriverRow_private_offset);
#line 8 "../src/Widgets/DriverRow.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_about_driver_row_get_property;
#line 8 "../src/Widgets/DriverRow.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_about_driver_row_set_property;
#line 8 "../src/Widgets/DriverRow.vala"
	G_OBJECT_CLASS (klass)->constructor = about_driver_row_constructor;
#line 8 "../src/Widgets/DriverRow.vala"
	G_OBJECT_CLASS (klass)->finalize = about_driver_row_finalize;
#line 8 "../src/Widgets/DriverRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ABOUT_DRIVER_ROW_DEVICE_PROPERTY, about_driver_row_properties[ABOUT_DRIVER_ROW_DEVICE_PROPERTY] = g_param_spec_string ("device", "device", "device", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 8 "../src/Widgets/DriverRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ABOUT_DRIVER_ROW_DRIVER_NAME_PROPERTY, about_driver_row_properties[ABOUT_DRIVER_ROW_DRIVER_NAME_PROPERTY] = g_param_spec_string ("driver-name", "driver-name", "driver-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 8 "../src/Widgets/DriverRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ABOUT_DRIVER_ROW_INSTALLED_PROPERTY, about_driver_row_properties[ABOUT_DRIVER_ROW_INSTALLED_PROPERTY] = g_param_spec_boolean ("installed", "installed", "installed", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 8 "../src/Widgets/DriverRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ABOUT_DRIVER_ROW_INSTALL_BUTTON_PROPERTY, about_driver_row_properties[ABOUT_DRIVER_ROW_INSTALL_BUTTON_PROPERTY] = g_param_spec_object ("install-button", "install-button", "install-button", gtk_check_button_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 8 "../src/Widgets/DriverRow.vala"
	about_driver_row_signals[ABOUT_DRIVER_ROW_INSTALL_SIGNAL] = g_signal_new ("install", ABOUT_TYPE_DRIVER_ROW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 439 "DriverRow.c"
}

static void
about_driver_row_instance_init (AboutDriverRow * self,
                                gpointer klass)
{
#line 8 "../src/Widgets/DriverRow.vala"
	self->priv = about_driver_row_get_instance_private (self);
#line 448 "DriverRow.c"
}

static void
about_driver_row_finalize (GObject * obj)
{
	AboutDriverRow * self;
#line 8 "../src/Widgets/DriverRow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, ABOUT_TYPE_DRIVER_ROW, AboutDriverRow);
#line 11 "../src/Widgets/DriverRow.vala"
	_g_free0 (self->priv->_device);
#line 12 "../src/Widgets/DriverRow.vala"
	_g_free0 (self->priv->_driver_name);
#line 15 "../src/Widgets/DriverRow.vala"
	_g_object_unref0 (self->priv->_install_button);
#line 8 "../src/Widgets/DriverRow.vala"
	G_OBJECT_CLASS (about_driver_row_parent_class)->finalize (obj);
#line 465 "DriverRow.c"
}

 G_GNUC_NO_INLINE static GType
about_driver_row_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (AboutDriverRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) about_driver_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AboutDriverRow), 0, (GInstanceInitFunc) about_driver_row_instance_init, NULL };
	GType about_driver_row_type_id;
	about_driver_row_type_id = g_type_register_static (gtk_list_box_row_get_type (), "AboutDriverRow", &g_define_type_info, 0);
	AboutDriverRow_private_offset = g_type_add_instance_private (about_driver_row_type_id, sizeof (AboutDriverRowPrivate));
	return about_driver_row_type_id;
}

GType
about_driver_row_get_type (void)
{
	static volatile gsize about_driver_row_type_id__once = 0;
	if (g_once_init_enter (&about_driver_row_type_id__once)) {
		GType about_driver_row_type_id;
		about_driver_row_type_id = about_driver_row_get_type_once ();
		g_once_init_leave (&about_driver_row_type_id__once, about_driver_row_type_id);
	}
	return about_driver_row_type_id__once;
}

static void
_vala_about_driver_row_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec)
{
	AboutDriverRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, ABOUT_TYPE_DRIVER_ROW, AboutDriverRow);
#line 8 "../src/Widgets/DriverRow.vala"
	switch (property_id) {
#line 8 "../src/Widgets/DriverRow.vala"
		case ABOUT_DRIVER_ROW_DEVICE_PROPERTY:
#line 8 "../src/Widgets/DriverRow.vala"
		g_value_set_string (value, about_driver_row_get_device (self));
#line 8 "../src/Widgets/DriverRow.vala"
		break;
#line 8 "../src/Widgets/DriverRow.vala"
		case ABOUT_DRIVER_ROW_DRIVER_NAME_PROPERTY:
#line 8 "../src/Widgets/DriverRow.vala"
		g_value_set_string (value, about_driver_row_get_driver_name (self));
#line 8 "../src/Widgets/DriverRow.vala"
		break;
#line 8 "../src/Widgets/DriverRow.vala"
		case ABOUT_DRIVER_ROW_INSTALLED_PROPERTY:
#line 8 "../src/Widgets/DriverRow.vala"
		g_value_set_boolean (value, about_driver_row_get_installed (self));
#line 8 "../src/Widgets/DriverRow.vala"
		break;
#line 8 "../src/Widgets/DriverRow.vala"
		case ABOUT_DRIVER_ROW_INSTALL_BUTTON_PROPERTY:
#line 8 "../src/Widgets/DriverRow.vala"
		g_value_set_object (value, about_driver_row_get_install_button (self));
#line 8 "../src/Widgets/DriverRow.vala"
		break;
#line 524 "DriverRow.c"
		default:
#line 8 "../src/Widgets/DriverRow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 8 "../src/Widgets/DriverRow.vala"
		break;
#line 530 "DriverRow.c"
	}
}

static void
_vala_about_driver_row_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec)
{
	AboutDriverRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, ABOUT_TYPE_DRIVER_ROW, AboutDriverRow);
#line 8 "../src/Widgets/DriverRow.vala"
	switch (property_id) {
#line 8 "../src/Widgets/DriverRow.vala"
		case ABOUT_DRIVER_ROW_DEVICE_PROPERTY:
#line 8 "../src/Widgets/DriverRow.vala"
		about_driver_row_set_device (self, g_value_get_string (value));
#line 8 "../src/Widgets/DriverRow.vala"
		break;
#line 8 "../src/Widgets/DriverRow.vala"
		case ABOUT_DRIVER_ROW_DRIVER_NAME_PROPERTY:
#line 8 "../src/Widgets/DriverRow.vala"
		about_driver_row_set_driver_name (self, g_value_get_string (value));
#line 8 "../src/Widgets/DriverRow.vala"
		break;
#line 8 "../src/Widgets/DriverRow.vala"
		case ABOUT_DRIVER_ROW_INSTALLED_PROPERTY:
#line 8 "../src/Widgets/DriverRow.vala"
		about_driver_row_set_installed (self, g_value_get_boolean (value));
#line 8 "../src/Widgets/DriverRow.vala"
		break;
#line 8 "../src/Widgets/DriverRow.vala"
		case ABOUT_DRIVER_ROW_INSTALL_BUTTON_PROPERTY:
#line 8 "../src/Widgets/DriverRow.vala"
		about_driver_row_set_install_button (self, g_value_get_object (value));
#line 8 "../src/Widgets/DriverRow.vala"
		break;
#line 568 "DriverRow.c"
		default:
#line 8 "../src/Widgets/DriverRow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 8 "../src/Widgets/DriverRow.vala"
		break;
#line 574 "DriverRow.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

